/*
 * SpaceTestApplet.java
 *
 * Created on October 29, 2005, 9:27 AM
 */

package Current;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.io.*;
import java.util.*;

// popups
import Current.popups.Settings.SettingsOnDemand;
import Current.popups.SearchResults.WordDisplayOnDemand;
import Current.popups.Help.HelpOnDemand;

// canvases
import Current.canvases.Search.BasicSearchCanvas;
import Current.canvases.ColorSelector.ColorSelectorCanvas;
import Current.canvases.Coordinate.CoordinateCanvas;
import Current.canvases.DebugButton.DebugButton;
import Current.canvases.Mouse.MouseCanvas;
import Current.canvases.ParameterSpace.*;
import Current.canvases.PopupLists.PopupListCanvasBasic;
import Current.canvases.Rational.RationalCanvas;
import Current.canvases.Title.TitleCanvas;
import Current.canvases.Plot.PlotCanvas;

import Current.manage.*;

/**
 *
 * @author  pat
 */
public class A2Basic extends Applet {
    
    Manager M;
    BasicSearchCanvas BSC;
    CoordinateCanvas CC;
    ColorSelectorCanvas CS;
    MouseCanvas MC;
    PlotCanvas PC;
    TitleCanvas TC;
    PopupListCanvasBasic PLC;
    SpaceCanvas SC;
    SpaceControlCanvas SCC;
    WordDisplayOnDemand WD;
    RationalCanvas R;
    
    HelpOnDemand HOD;
    
    
    public void init(){
        // this allows us to detect the TAB key
        setFocusTraversalKeys(KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
        Collections.EMPTY_SET);
        
        setBackground(new Color(0,0,150));
        
        M=new Manager(this);
        
        BSC=new BasicSearchCanvas(M);
        BSC.setSize();
        
        CC=new CoordinateCanvas(M);
        
        CS=new ColorSelectorCanvas(M,60,240);
        CS.setSize(60,240);
        
        MC=new MouseCanvas(M);
        MC.setSize(61,120);
        
        PC=new PlotCanvas(M);
        PC.setSize();
        
        PLC=new PopupListCanvasBasic(M);
        PLC.setSize();
        
        R=new RationalCanvas(M);
        R.setSize(60,208);
        
        TitleCanvas TC=new TitleCanvas(M);
        
        SC=new SpaceCanvas(M);
        //SC.setSize(getWidth()-61,getHeight()-2*PTC.getSize().height);
        
        SCC= new SpaceControlCanvas(SC,M);
        SCC.setSize();
        
        
        WD=new WordDisplayOnDemand(M);
        HOD=new HelpOnDemand(M);
       
        Container C1=new Container();
        C1.setSize(61, getHeight());
        C1.setLayout(new BorderLayout(0,5));
        C1.add(CS,BorderLayout.NORTH);
        C1.add(MC,BorderLayout.SOUTH);
        
        Container C3=new Container();
        C3.setSize(61, getHeight());
        C3.setLayout(new BorderLayout(0,5));
        C3.add(R,BorderLayout.NORTH);
        C3.add(TC,BorderLayout.SOUTH);
        
        
        Container North=new Container();
        North.setSize(getWidth()-61, TC.getHeight());
        North.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
        North.add(CC);
        //North.add(PTC);
        North.add(PLC);
        North.add(PC);
        
        Container South=new Container();
        South.setSize(getWidth()-61, TC.getHeight());
        South.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
        South.add(SCC);
        South.add(BSC);
        South.add(PC);
        
        Container C2=new Container();
        C2.setSize(getWidth()-61, getHeight());
        C2.setLayout(new BorderLayout(0,0));
        C2.add(North,BorderLayout.NORTH);
        C2.add(SC,BorderLayout.CENTER);
        C2.add(South,BorderLayout.SOUTH);
        
        
        setLayout(new BorderLayout(0,0));
        add(C1,BorderLayout.EAST);
        add(C2,BorderLayout.CENTER);
        add(C3,BorderLayout.WEST);
    }
    
    private static class WinList implements WindowListener{
        Frame F;
        public WinList(Frame F){
            this.F=F;
        }
        
        public void windowActivated(java.awt.event.WindowEvent windowEvent) {
        }
        
        public void windowClosed(java.awt.event.WindowEvent windowEvent) {
        }
        
        public void windowClosing(java.awt.event.WindowEvent windowEvent) {
            F.dispose();
            System.exit(0);
        }
        
        public void windowDeactivated(java.awt.event.WindowEvent windowEvent) {
        }
        
        public void windowDeiconified(java.awt.event.WindowEvent windowEvent) {
        }
        
        public void windowIconified(java.awt.event.WindowEvent windowEvent) {
        }
        
        public void windowOpened(java.awt.event.WindowEvent windowEvent) {
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        A2Basic a=new A2Basic();
        a.setSize(640,480);
        Frame F=new Frame("Web McBilliards");
        F.setBackground(new Color(0,0,50));
        F.addWindowListener(new WinList(F));
        a.init();
        F.add(a);
        F.pack();
        F.setVisible(true);
    }
    
}
