package Current.basic;

import Current.*;


import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;


public class IntegerSelector {
    public ListenTriangle up,down;
    public int x,y,w,h;
    public int min,max,step,val;
    public String S;


    public IntegerSelector(int x,int y,int w,int h,int val,int min,int max,int step) {
    this.x=x;
    this.y=y;
    this.w=w;
    this.h=h;
    this.val=val;
    this.min=min;
    this.max=max;
    this.step=step;
    S="";

    down=new ListenTriangle();
    down.z[0]=new Complex(x+w/2-2,y);
    down.z[1]=new Complex(x,y+h/2);
    down.z[2]=new Complex(x+w/2-2,y+h);
   

    up=new ListenTriangle();
    up.z[0]=new Complex(x+w/2+2,y);
    up.z[1]=new Complex(x+w,y+h/2);
    up.z[2]=new Complex(x+w/2+2,y+h);
    }


    public void modify(Point X) {
	if(down.inside(X)==1) val=val-step;
	if(up.inside(X)==1) val=val+step;
	if(val<min) val=val+step;
	if(val>max) val=val-step;
    }

    public int isModified(Point X) {
	if(down.inside(X)==1) return(1);
	if(up.inside(X)==1) return(1);
	return(0);
    }





    public void modifyCyclic(Point X) {
	if(down.inside(X)==1) 	val=(val-step+max)%max;
	if(up.inside(X)==1) 	val=(val+step)%max;
    }



    public void render(Graphics g,Color C1,Color C2) {
    up.render(g,C1,C2);
    down.render(g,C1,C2);  
    g.setFont(new Font("Helvetica",Font.PLAIN,12));
    g.setColor(Color.white);
    Integer I=new Integer(val);
    g.drawString(I.toString(),x+w+6,y+h/2+4);
    g.drawString(S,x,y+h+12);
    }


    public void render(Graphics g,Color C1,Color C2,Color C3) {
    up.render(g,C1,C2);
    down.render(g,C1,C2);  
    g.setFont(new Font("Helvetica",Font.PLAIN,12));
    g.setColor(C3);
    Integer I=new Integer(val);
    g.drawString(I.toString(),x+w+8,y+h/2+4);
    g.drawString(S,x-1,y+h+12);
    }


    public void render(Graphics g,Color C1,Color C2,Color C3,int k) {
    up.render(g,C1,C2);
    down.render(g,C1,C2);  
    g.setFont(new Font("Monospaced",Font.PLAIN,k));
    g.setColor(C3);
    Integer I=new Integer(val);
    g.drawString(I.toString(),x+w+8,y+h/2+4);
    g.drawString(S,x-1,y+h+12);
    }


}
