package Current.basic;
import Current.*;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;




public class WordIcon {
    public int x,y,w,h,mode,on;
    public String W;
    public VertexPair VP;

    public WordIcon(int x,int y,int w,int h,String W,int mode) {
	this.x=x;
	this.y=y;
	this.h=h;
	this.w=w;
	this.W=W;
	this.mode=mode;
	this.on=0;
	VP=new VertexPair();

    }



    /**This option draws things so that the midpoints of the
       edges lie in the integer lattice*/

    public static Complex[] rawPath(String W) {	
	Complex[] v=new Complex[4];
	v[1]=new Complex(1,-2);
	v[3]=new Complex(1,1);
	v[2]=new Complex(-2,1);
	return(rawPath(W,v));
    }

    public static Complex[] rawPathRegular(String W) {	
        double pi=Math.PI;
	double arg1=pi/6+pi/2;
	double arg2=arg1+2*pi/3;
	double arg3=arg2+2*pi/3;
	Complex[] v=new Complex[4];
	v[1]=new Complex(Math.cos(arg1),Math.sin(arg1));
	v[2]=new Complex(Math.cos(arg2),Math.sin(arg2));
	v[3]=new Complex(Math.cos(arg3),Math.sin(arg3));
	return(rawPath(W,v));
    }





    public static Complex[] rawPath(String W,Complex[] v) {
	int n=W.length();
	Complex[] V=new Complex[n+2];
	String S=new String();
	Complex w1=new Complex(0,0);
	Complex direction=new Complex(0,0);

	for(int i=0;i<n;++i) {
	 S=W.substring(i,i+1);
         if(S.compareTo("1")==0) {direction.x=v[1].x;direction.y=v[1].y;}
	 if(S.compareTo("2")==0) {direction.x=v[2].x;direction.y=v[2].y;}
	 if(S.compareTo("3")==0) {direction.x=v[3].x;direction.y=v[3].y;}

	 if(i%2==1) {direction.x=-direction.x;direction.y=-direction.y;}
	 w1.x=w1.x+direction.x;
	 w1.y=w1.y+direction.y;
	 V[i]=new Complex(w1.x,w1.y);
	}
	V[n]=new Complex(V[0].x,V[0].y);
	return(V);
    }




    public static Complex[] getLocation(Complex[] V,int n) {
	double mx,my,Mx,My;
      mx=1000000;
      my=1000000;
      Mx=-1000000;
      My=-1000000;
      for(int i=0;i<n;++i) {
	if(mx>V[i].x) mx=V[i].x;
	if(Mx<V[i].x) Mx=V[i].x;
	if(my>V[i].y) my=V[i].y;
	if(My<V[i].y) My=V[i].y;
      }
      Complex[] Z=new Complex[2];  
      Z[0]=new Complex(Mx-mx,My-my);               //dimensions
      Z[1]=new Complex((Mx+mx)/2.0,(My+my)/2.0);   //center
      return(Z);
    }


    public int oddSquareTest() {
	int N=W.length();
	int d2=-1;
	int d1=-1;
	for(int i=0;i<N;++i) {
	    d1=Converter.getDigit(W,i);
	    d2=Converter.getDigit(W,i+N/2);
	    if(d1!=d2) return(0);
	}
	return(1);
    }


    public int palindromeTest() {
	CombinatorialTriangle[] CT=CombinatorialTriangle.unfold(W);
	int palindrome=Converter.palindromeTest(CT);
	return(palindrome);
    }




    /**here is the main routine*/

    public void pathRender(Graphics2D g,Color[] C) {
	int n=W.length();

	if(n>0) {
        g.translate(x,y);

	int palindrome=palindromeTest();
	int oddsquare=oddSquareTest();

	if(oddsquare+palindrome==0) {
	if(on==0) g.setColor(C[1]);
	if(on==1) g.setColor(C[2]);
	g.fillRect(0,0,w,h);
	if(on==0) g.setColor(C[2]);
	if(on==1) g.setColor(C[3]);
        g.drawRect(0,0,w,h);
	}


	if(palindrome==1) {
	if(on==0) g.setColor(C[6]);
	if(on==1) g.setColor(C[7]);
	g.fillRect(0,0,w,h);
	if(on==0) g.setColor(C[7]);
	if(on==1) g.setColor(C[8]);
        g.drawRect(0,0,w,h);
	}


	if(oddsquare==1) {
	if(on==0) g.setColor(C[9]);
	if(on==1) g.setColor(C[10]);
	g.fillRect(0,0,w,h);
	if(on==0) g.setColor(C[10]);
	if(on==1) g.setColor(C[11]);
        g.drawRect(0,0,w,h);
	}

	Complex[] V=rawPath(W);
	Complex[] Z=getLocation(V,n);
	double size=Z[0].x;
	if(size<Z[0].y) size=Z[0].y;
	int bb=w;
	if(bb>h) bb=h;
	size=bb/size;
	size=size*.95;

	double xx=Z[1].x;
	double yy=Z[1].y;
	float x1,y1,x2,y2;

	GeneralPath path=new GeneralPath();
	x1=(float)((V[0].x-xx)*size+w/2);
	y1=(float)((V[0].y-yy)*size+h/2);
            path.moveTo(x1,y1);

	for(int i=0;i<n;++i) {
	    x2=(float)((V[i+1].x-xx)*size+w/2);
	    y2=(float)((V[i+1].y-yy)*size+h/2);
            path.lineTo(x2,y2);
	}
	g.setColor(C[4]);	
        g.draw(path);


	if(VP!=null) {
	    path.reset();
	    int min=Math.min(VP.e1,VP.e2);
	    int max=Math.max(VP.e1,VP.e2);
	    x1=(float)((V[min].x-xx)*size+w/2);
	    y1=(float)((V[min].y-yy)*size+h/2);
            path.moveTo(x1,y1);

	for(int i=min;i<max;++i) {
	    x2=(float)((V[i+1].x-xx)*size+w/2);
	    y2=(float)((V[i+1].y-yy)*size+h/2);
            path.lineTo(x2,y2);
	}
	g.setColor(C[5]);
        g.draw(path);
	}
       
	g.setColor(Color.white);
	Integer I=new Integer(n);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	if(mode==0)	g.drawString(I.toString(),1,h+13);
	if(mode==1)	g.drawString(I.toString(),1,-4);
	if(mode==2)     g.drawString(I.toString(),h+8,h-2);
        g.translate(-x,-y);
	}
    }



    public void pathRender(Graphics2D g) {
	    Color[] C=new Color[13];
            C[1]=new Color(220,0,0);
            C[2]=new Color(120,0,0);
            C[3]=new Color(255,0,0);
            C[4]=Color.white;
            C[5]=Color.white;  
            C[6]=new Color(0,0,220);
            C[7]=new Color(0,0,120);
            C[8]=new Color(0,0,255); 
            C[9]=new Color(0,180,0);
            C[10]=new Color(0,100,0);
            C[11]=new Color(0,255,0);
            pathRender(g,C);
    }




    public void pathRender2(Graphics2D g,VertexPair VV) {
	    this.VP=VV;
	    Color[] C=new Color[13];
            C[1]=new Color(0,0,120);
            C[2]=new Color(0,0,120);
            C[3]=new Color(0,0,200);
            C[4]=new Color(200,0,200);
	    C[5]=new Color(255,255,0);
	    if(VP==null) {  
                 C[4]=new Color(100,100,100);
                 C[5]=new Color(100,100,100);
	    }
            C[6]=new Color(0,0,120);
            C[7]=new Color(0,0,120);
            C[8]=new Color(0,0,200); 
            C[9]=new Color(0,0,120);
            C[10]=new Color(0,0,120);
            C[11]=new Color(0,0,200);
            pathRender(g,C);
    }










    public int inside(Point p) {
        int test=0;
	if((p.x>x)&&(p.x<x+w)&&(p.y>y)&&(p.y<y+h)) test=1;
	return(test);
    }

    /**Here some other renditions of the word*/


    //(X,Y) is the corner point
    public void wordRender1(Graphics g ) {
	   int X=x-4;
	   int Y=y+9;
	   int len=W.length();
           g.setColor(Color.white);
           g.setFont(new Font("Nonospaced",Font.PLAIN,12));
	   Integer Len=new Integer(len);
	   g.drawString(Len.toString(),X+5,Y-13);

           g.setFont(new Font("Monospaced",Font.PLAIN,10));
	   int a=X;
	   int b=Y;
	   for(int i=0;i<len;++i) {
	       int j=i+1;
	       if(i%4==0) a=a+4;
	       String WW=W.substring(i,j);
	       g.drawString(WW,a,b+1);
	       if(j%32==0) {b=b+12;a=X;}
	       if(j%32!=0) a=a+5;
	   }
	}



    //(X,Y) is the corner point
    public void wordRender2(Graphics g) {
	int X=x-4;
	int Y=y+9;
	String V=toAlphabet();
	   int len=V.length();
           g.setColor(Color.white);
           g.setFont(new Font("Nonospaced",Font.PLAIN,12));
	   Integer Len=new Integer(len);
	   g.drawString(Len.toString(),X+5,Y-13);

           g.setFont(new Font("Monospaced",Font.PLAIN,12));
	   int a=X;
	   int b=Y;
	   for(int i=0;i<len;++i) {
	       int j=i+1;
	       if(i%4==0) a=a+4;
	       String WW=V.substring(i,j);
	       g.drawString(WW,a,b+1);
	       if(j%24==0) {b=b+16;a=X;}
	       if(j%24!=0) a=a+7;
	   }
	}



    public String toAlphabet() {
	String V="";
	int L=W.length();

	if(L%4==0) {
	    for(int k=0;k<L;k=k+4) {
		String WW=W.substring(k,k+4);
		WW=alphabetize(WW);
		V=V+WW;
	    }
	}

	if(L%4==2) {
          for(int k=0;k<L-4;k=k+4) {
		String WW=W.substring(k,k+4);
	        WW=alphabetize(WW);
		V=V+WW;
	  }
	  String WW=W.substring(L-2,L);	
          WW=alphabetize(WW);
	  V=V+WW;
	}
	return(V);
    }




    public static String alphabetize(String X) {

	if(X.compareTo("1212")==0) return("a");
	if(X.compareTo("1213")==0) return("b");
	if(X.compareTo("1231")==0) return("c");
	if(X.compareTo("1232")==0) return("d");

	if(X.compareTo("1312")==0) return("e");
	if(X.compareTo("1313")==0) return("f");
	if(X.compareTo("1321")==0) return("g");
	if(X.compareTo("1323")==0) return("h");

	if(X.compareTo("2121")==0) return("i");
	if(X.compareTo("2123")==0) return("j");
	if(X.compareTo("2131")==0) return("k");
	if(X.compareTo("2132")==0) return("l");

	if(X.compareTo("2312")==0) return("m");
	if(X.compareTo("2313")==0) return("n");
	if(X.compareTo("2321")==0) return("o");
	if(X.compareTo("2323")==0) return("p");

	if(X.compareTo("3121")==0) return("q");
	if(X.compareTo("3123")==0) return("r");
	if(X.compareTo("3131")==0) return("s");
	if(X.compareTo("3132")==0) return("t");

	if(X.compareTo("3212")==0) return("u");
	if(X.compareTo("3213")==0) return("v");
	if(X.compareTo("3231")==0) return("w");
	if(X.compareTo("3232")==0) return("x");

	if(X.compareTo("12")==0) return("A");
	if(X.compareTo("13")==0) return("B");
	if(X.compareTo("21")==0) return("C");
	if(X.compareTo("23")==0) return("D");
	if(X.compareTo("31")==0) return("E");
	if(X.compareTo("32")==0) return("F");

	return(X);
    }

    /**here is the main routine*/

    public void pathRenderRegular(Graphics2D g,Color[] C) {
	int n=W.length();

	if(n>0) {
        g.translate(x,y);

	int palindrome=palindromeTest();
	int oddsquare=oddSquareTest();

	if(oddsquare+palindrome==0) {
	if(on==0) g.setColor(C[1]);
	if(on==1) g.setColor(C[2]);
	g.fillRect(0,0,w,h);
	if(on==0) g.setColor(C[2]);
	if(on==1) g.setColor(C[3]);
        g.drawRect(0,0,w,h);
	}


	if(palindrome==1) {
	if(on==0) g.setColor(C[6]);
	if(on==1) g.setColor(C[7]);
	g.fillRect(0,0,w,h);
	if(on==0) g.setColor(C[7]);
	if(on==1) g.setColor(C[8]);
        g.drawRect(0,0,w,h);
	}


	if(oddsquare==1) {
	if(on==0) g.setColor(C[9]);
	if(on==1) g.setColor(C[10]);
	g.fillRect(0,0,w,h);
	if(on==0) g.setColor(C[10]);
	if(on==1) g.setColor(C[11]);
        g.drawRect(0,0,w,h);
	}

	Complex[] V=rawPathRegular(W);
	Complex[] Z=getLocation(V,n);
	double size=Z[0].x;
	if(size<Z[0].y) size=Z[0].y;
	int bb=w;
	if(bb>h) bb=h;
	size=bb/size;
	size=size*.95;

	double xx=Z[1].x;
	double yy=Z[1].y;
	float x1,y1,x2,y2;

	GeneralPath path=new GeneralPath();
	x1=(float)((V[0].x-xx)*size+w/2);
	y1=(float)((V[0].y-yy)*size+h/2);
            path.moveTo(x1,y1);

	for(int i=0;i<n;++i) {
	    x2=(float)((V[i+1].x-xx)*size+w/2);
	    y2=(float)((V[i+1].y-yy)*size+h/2);
            path.lineTo(x2,y2);
	}
	g.setColor(C[4]);	
        g.draw(path);


	if(VP!=null) {
	    path.reset();
	    int min=Math.min(VP.e1,VP.e2);
	    int max=Math.max(VP.e1,VP.e2);
	    x1=(float)((V[min].x-xx)*size+w/2);
	    y1=(float)((V[min].y-yy)*size+h/2);
            path.moveTo(x1,y1);

	for(int i=min;i<max;++i) {
	    x2=(float)((V[i+1].x-xx)*size+w/2);
	    y2=(float)((V[i+1].y-yy)*size+h/2);
            path.lineTo(x2,y2);
	}
	g.setColor(C[5]);
        g.draw(path);
	}
       
	g.setColor(Color.white);
	Integer I=new Integer(n);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	if(mode==0)	g.drawString(I.toString(),1,h+13);
	if(mode==1)	g.drawString(I.toString(),1,-4);
	if(mode==2)     g.drawString(I.toString(),h+8,h-2);
        g.translate(-x,-y);
	}
    }

    public void pathRenderRegular(Graphics2D g) {
	    Color[] C=new Color[13];
            C[1]=new Color(220,0,0);
            C[2]=new Color(120,0,0);
            C[3]=new Color(255,0,0);
            C[4]=Color.white;
            C[5]=Color.white;  
            C[6]=new Color(0,0,220);
            C[7]=new Color(0,0,120);
            C[8]=new Color(0,0,255); 
            C[9]=new Color(0,180,0);
            C[10]=new Color(0,100,0);
            C[11]=new Color(0,255,0);
            pathRenderRegular(g,C);
    }

    
}


