/*
 * DebugButton.java
 *
 * Created on June 28, 2006, 11:41 AM
 */

package Current.canvases.DebugButton;

import Current.manage.*;
import Current.*;

import java.awt.*;
import java.awt.event.*;

import org.pat.graphics.boxed.ListenString;

/**
 *
 * @author  pat
 */
public class DebugButton extends Canvas implements MouseListener {
    Manager M;
    ListenString ls;
    
    /** Creates a new instance of DebugButton */
    public DebugButton(Manager M) {
        this.M=M;

        setBackground(new Color(0,0,255));
        
        setFont(new Font("Helvetica",Font.PLAIN,10));
        addMouseListener(this);
        
        ls=new ListenString("debug",this);
        ls.setColors(Color.white, new Color(50,100,255));
        ls.setTop(2);
    }
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        //g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
        //RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
        
        ls.setHorizontalCenter(getWidth()/2.0);
        ls.render(g);
    }
    
    public Dimension getPreferredSize() {
        return new Dimension((int)(4+ls.getWidth()), (int)(4+ls.getHeight()));
    }
    
    public void mouseClicked(MouseEvent e) {
        if (ls.contains(e)) {
            StringBuffer b=new StringBuffer();
            b.append("<center><b>Debugging Information</b></center><br>");
            
            b.append("Java Vendor: <b>");
            b.append(System.getProperty("java.vendor"));
            b.append("</b><br>");
            
            b.append("Java Version: <b>");
            b.append(System.getProperty("java.version"));
            b.append("</b><br>");
            
            b.append("Java Class Version: <b>");
            b.append(System.getProperty("java.class.version"));
            b.append("</b><br>");
            
            b.append("Operating System: <b>");
            b.append(System.getProperty("os.name"));
            b.append("</b><br>");
            
            b.append("Operating System Architecture: <b>");
            b.append(System.getProperty("os.arch"));
            b.append("</b><br>");
 
            M.mcbSend(HelpString.fromBody(b.toString()));
        }
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
}
