/*
 * PlotCanvas.java
 *
 * Created on October 30, 2005, 4:36 PM
 */

package Current.canvases.Plot;

import Current.plot.Plotters.*;
import Current.manage.*;
import Current.manage.Popup.*;
import Current.gui.*;
import Current.basic.*;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;

import org.pat.graphics.boxed.ListenString;

/**
 *
 * @author  pat
 */
public class PlotCanvas extends Container
implements MouseListener, Runnable{
    
    public class PlotTypeMenu extends Canvas
    implements MouseListener, HearingPopup {
        ListenString[] LS;
        ListenString title;
        Current.gui.PopupMenu PM;
        
        public PlotTypeMenu(int X, int Y) {
            setBackground(menuBg);
            setFont(new Font("sanserif", Font.PLAIN, 12));
            
            double x=4, y=4;
            title=new ListenString("mode", this);
            title.setColors(Color.white, menuBg);
            title.showBorder=false;
            title.setLeft(x);
            title.setTop(y);
            y=title.getBottom()+4;
            LS=new ListenString[names.length];
            
            for (int i=0; i< LS.length; i++) {
                LS[i]=new ListenString(names[i],this);
                LS[i].setColors(buttonFg, types[i].getColor());
                LS[i].setLeft(x);
                LS[i].setTop(y);
                y=LS[i].getBottom();
            }
            setSize();
            addMouseListener(this);
            PM=new Current.gui.PopupMenu(PlotCanvas.this,this,X,Y,this);
        }
        
        private void setSize(){
            int x=0,y=0,temp;
            for (int i=0; i<LS.length; i++){
                temp=(int)(LS[i].getRight());
                if (temp>x)
                    x=temp;
                temp=(int)(LS[i].getBottom());
                if (temp>y)
                    y=temp;
            }
            setSize(x+5,y+5);
        }
        
        public void onClose(){
        }
        
        public void paint(Graphics gfx){
            Graphics2D g=(Graphics2D) gfx;
            
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            title.render(g);
            for (int i=0; i<LS.length; i++) {
                LS[i].render(g);
            }
            //doc.render(g);
            Dimension D=this.getSize();
            g.setColor(new Color(100,255,100));
            g.drawRect(0,0,D.width-1,D.height-1);
        }
        
        public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
            for (int j=0; j<LS.length; j++) {
                if (LS[j].contains(mouseEvent)) {
                    i=j;
                    PlotCanvas.this.resetComponent();
                    //PlotCanvas.this.repaint();
                }
            }
            PM.forceClose();
        }
        
        public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
        }
        
        public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
        }
        
        public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
        }
        
        public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
        }
        
        /** called when the menu closes */
        public void popupClosed(Component C) {
            PTM=null;
        }
        
    }
    
    Manager M;
    
    // buttons
    ListenString plotType, plot,doc2;
    
    public XPlotter[] types={
        new XFillPlotter(),
        new XPackPlotter(),
        new XCoverPlotter(),
        new XZonePlotter(),
        new XBilliardLikePlotter(),
        new XNewPlotter()
    };
    String[] names;
    boolean[] enabled;
    
    /** This is the width taken up by the default buttons*/
    int half_width, height;
    
    // Colors
    Color buttonBg, buttonFg;
    
    // constants
    static final int padding=4;
    
    // The thread is used when plotting.
    Thread T=null;
    
    private static Color
    //bgColor=new Color(100,0,100),
    menuBg=new Color(50,0,100);
    
    /** The plot-type menu */
    PlotTypeMenu PTM;
    
    /** Allows the user to interupt a plot */
    public Interrupter I;
    
    /** currently selected plot type */
    public int i;
    
    /** Plot settings for current canvas */
    Component current=null;
    
    /** set whether or not the plot button should be enabled and shown */
    public boolean plot_enabled=true;
    
    public void resetComponent() {
        if (current!=null) {
            this.remove(current);
        }
        current=types[i].getController(M);
        current.setSize(getWidth()-half_width-1, getHeight()-2);
        current.setLocation(half_width,1);
        current.setBackground(this.getBackground());
        this.add(current);
    }
    
    /** Creates a new instance of PlotCanvas */
    public PlotCanvas(Manager M) {
        this.M=M;
        
        int num=5;
        names=new String[types.length];
        enabled=new boolean[types.length];
        
        
        for (int i=0; i<types.length; i++){
            names[i]=types[i].getName();
            enabled[i]=types[i].canRun();
        }
        
        this.i=0; // default to "fill plot"
        
        // Colors
        setBackground(new Color(30,60,250));
        buttonBg=new Color(0,250,250);
        buttonFg=Color.black;
        
        // Buttons
        setFont(new Font("Helvetica",Font.PLAIN,12));
        
        double x,y;
        x=y=padding;
        plotType=new ListenString(names[i],names,this);
        plotType.setLeft(2);
        plotType.setTop(y);
        plotType.setColors(buttonFg, buttonBg);
        
        y=plotType.getBottom()+padding;
        String[] options={"plot","stop"};
        plot=new ListenString("plot", options, this);
        doc2=new ListenString("?",this);     //Pat added
        plot.setLeft(2);
        plot.setTop(y);
        plot.setColors(buttonFg, buttonBg);
        doc2.setLeft(2+plot.getRight());      //Pat added
        doc2.setTop(y);                       //Pat added
        doc2.setColors(buttonFg, buttonBg);   //Pat added
        
        height=(int)plot.getBottom()+padding;
        
        addMouseListener(this);
        
        half_width=(int)doc2.getRight()+padding;
        int temp=(int)plotType.getRight()+padding;
        if (temp>half_width) {
            half_width=temp;
        }
        
        setSize();
        
        
        resetComponent();
    }
    
    /** find the next enabled plot type */
    /*public void inc(){
        i=(i+1)%types.length;
        while (!enabled[i])
            i=(i+1)%types.length;
    }*/
    
    public Dimension getPreferredSize() {
        Dimension d;
        int maxx=0,maxy=0;
        for (int i=0; i<types.length; i++) {
            d=types[i].getController(M).getPreferredSize();
            if (d.width>maxx) {
                maxx=d.width;
            }
            if (d.height>maxy) {
                maxy=d.height;
            }
        }
        maxy=maxy+2;
        maxx=maxx+half_width+1;
        int temp=(int)(plot.getBottom()+padding);
        if (temp>maxy) {
            maxy=temp;
        }
        return new Dimension(maxx,maxy);
    }
    
    /** set the canvas size to some minimal but appropriate size. */
    public void setSize(){
        setSize(getPreferredSize());
    }
    
    public void paint(Graphics gfx) {
        super.paint(gfx);
        Graphics2D g=(Graphics2D) gfx;
        
        Dimension D=this.getSize();
        g.setColor(getBackground());
        g.fillRect(1,1,D.width-2,D.height-2);
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        //g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
        //RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
        
        plotType.str=names[i];
        plotType.setColors(buttonFg, types[i].getColor());
        plotType.render(g);
        if (plot_enabled) {
            plot.render(g);
        }
        doc2.render(g);
        g.setColor(new Color(100,180,255));
        g.drawRect(0,0,D.width-1,D.height-1);
    }
    
    public XPlotter getPlotter() {
        return types[i];
    }
    
    public void plot() {
        plot.str="stop";
        repaint();
        T=new Thread(this);
        T.setName(""+getClass().getName()+" Thread");
        T.start();
    }
    
    public void donePlot() {
        plot.str="plot";
        repaint();
        T=null;
    }
    
    public void run() {
        try {
            I=new Interrupter();
            Tile tile=types[i].plot(M.getWord(),M.getColor(), I, M);
            if ((tile!=null)&&(! I.isInterrupted())) {
                M.plotTile(tile);
            } else {
                if (tile==null)
                    System.err.println("PlotCanvas: No tile found.");
            }
        } catch (Throwable t) {
            System.err.println("Some error occurred while plotting");
            System.err.flush();
            t.printStackTrace();
        }
        donePlot();
    }
    
    public void interrupt() {
        if (I!=null) {
            I.interrupt();
            donePlot();
        }
    }
    
    public void mouseClicked(MouseEvent e) {
        if ((plot_enabled) && (plot.contains(e.getX(),e.getY()))) {
            if (T==null) {
                plot();
            } else {
                // interupt the plot
                interrupt();
            }
        } else if (plotType.contains(e.getX(),e.getY())) {
            if (PTM==null) {
                PTM=new PlotTypeMenu(
                (int)(plotType.getLeft()),(int)(plotType.getTop()));
            } else {
                PTM.PM.forceClose();
            }
            
            //inc();
            repaint();
        } else if(doc2.contains(e.getX(),e.getY())) {
            //types[i].document();
            document();
        }
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void document() {
        M.mcbSend(new HelpDocument("Plotting.html"));
        //M.setExplain("This is the plot window...");
    }
    
    /** return true iff we are currently plotting something */
    public boolean isPlotting() {
        return (T!=null);
    }
}

