/*
 * PopupListCanvas.java
 *
 * Created on October 30, 2005, 8:59 PM
 */

package Current.canvases.PopupLists;

import Current.gui.*;
import Current.manage.*;
import Current.manage.Popup.*;

import java.awt.*;
import java.awt.event.*;

import org.pat.graphics.boxed.ListenString;

import Current.popups.Memory.TileMemoryContainer;
import Current.popups.PopupManager.PopupManagerPopup;
/**
 *
 * @author  pat
 */
public class StandardPopupListCanvas extends DBCanvas implements MouseListener {
    Manager M;
    
    Class[] classes={
             Current.popups.Unfold.UnfoldContainer.class,
             TileMemoryContainer.class,
             Current.popups.WhereAmI.WhereAmICanvas.class,
             Current.popups.AnimatedWord.AnimatedWordContainer.class,
             PopupManagerPopup.class};

    String[] names={"unfolding","memory","where am i?","word","more popups"};
    ListenString[] ls=new ListenString[classes.length];
    ListenString doc;
    
    // Colors
    Color buttonBg, buttonFg, selectedBg, selectedFg;
    
    // Constants
    int padding;
    
    /** Creates a new instance of PopupListCanvas */
    public StandardPopupListCanvas(Manager M) {
        this.M=M;
        M.addListener(this);
        
        // Colors
        setBackground(new Color(0,100,0));
        buttonFg=Color.black;
        selectedFg=Color.black;
        buttonBg=new Color(100,255,100);
        selectedBg=Color.yellow;
        
        
        // Buttons
        setFont(new Font("sanserif", Font.PLAIN, 12));
        padding=4;
        
        for (int i=0; i<classes.length; i++) {
            M.PopupM.support(classes[i],names[i]);
            ls[i]=new ListenString(names[i], this);
        }
        doc=new ListenString("?", this);
        
        double x=padding,y=padding;
        
        x=padding;
        y=padding;
        ls[0].setLeft(x); ls[0].setTop(y);
        
        x=ls[0].getRight()+padding;
        ls[3].setLeft(x); ls[3].setTop(y);
        
        x=ls[3].getRight()+padding;
        ls[1].setLeft(x); ls[1].setTop(y);
                
        x=ls[1].getRight()+padding;
        doc.setLeft(x); doc.setTop(y);
                
        y=ls[0].getBottom()+padding;
        x=padding;
        ls[2].setLeft(x); ls[2].setTop(y);
                
        x=ls[2].getRight()+padding;
        ls[4].setLeft(x); ls[4].setTop(y);
        
        doc.setColors(buttonFg, buttonBg);
        //doc.showBorder=false;
        
        addMouseListener(this);
        setSize();
    }
    
    public void setSize(){
        int x=0,y=0,temp;
        for (int i=0; i<ls.length; i++){
            temp=(int)(ls[i].getRight());
            if (temp>x)
                x=temp;
            temp=(int)(ls[i].getBottom());
            if (temp>y)
                y=temp;
        }
        temp=(int)(doc.getRight());
        if (temp>x)
            x=temp;
        setSize(x+padding,y+padding);
    }
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        //g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
        //RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
        
        
        for (int i=0; i<ls.length; i++) {
            if (M.PopupM.isUp(classes[i])) {
                ls[i].setColors(selectedFg, selectedBg);
            } else {
                ls[i].setColors(buttonFg, buttonBg);
            }
            ls[i].render(g);
        }
        doc.render(g);
        Dimension D=this.getSize();
        g.setColor(new Color(100,255,100));
        g.drawRect(0,0,D.width-1,D.height-1);
    }
    
    
    
    public void mouseClicked(MouseEvent e) {
        for (int i=0; i<ls.length; i++) {
            if (ls[i].contains(e.getX(),e.getY())){
                if (! M.PopupM.isUp(classes[i])) {
                    M.PopupM.constructPopup(classes[i]);
                }
            }
        }
        if (doc.contains(e.getX(),e.getY()))
            document();
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void document(){
        M.mcbSend(new HelpDocument("StandardPopupListCanvas.html"));
        //M.setExplain("You can select a popup from this window. Press one of these buttons and a new window will appear.");
    }
    
    public void mcbReceive(PopupManager.PopupManagerChange msg) {
        repaint();
    }
}

