/*
 * TitleCanvas.java
 *
 * Created on November 3, 2005, 11:24 AM
 */

package Current.canvases.Title;

import Current.basic.*;
import Current.manage.*;
import Current.gui.*;

import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author  pat; modified by Rich
 */
public class TitleCanvas extends DBCanvas implements MouseListener {
    Manager M;
    ListenSquare L;
    
    
    /** Creates a new instance of PatTitleCanvas */
    public TitleCanvas(Manager M) {
        this.M=M;
        setBackground(new Color(0,0,255));
        addMouseListener(this);
        setSize(60,155);
        L=new ListenSquare(3,140,45,15,Color.white);
        L.on=1;
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(60,158);
    }
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
        g.setColor(Color.yellow);
        verticalDraw(g,3,13,11,"McBILLIARDS");
        g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
        verticalDraw(g,30,13,10,"Pat Hooper");
        verticalDraw(g,48,13,10,"Rich Schwartz");
        L.render(g,new Color(50,100,255));
        g.drawString("? info ?",5,152);
        g.setColor(new Color(50,150,255));
        g.drawString("9 Jun 06",3,136);
        g.drawRect(0,0,getWidth()-1,getHeight()-1);
    }
    
    
    
    public void verticalDraw(Graphics g,int x,int y,int k,String S) {
        int xx=x;
        int yy=y;
        for(int i=0;i<S.length();++i) {
            String SS=S.substring(i,i+1);
            g.drawString(SS,xx,yy);
            yy=yy+k;
        }
    }
    
    
    
    
    
    
    public void document() {
        M.mcbSend(new HelpDocument("about.html"));
        //M.setExplain("Web McBilliards\n\nby Pat Hooper and Rich Schwartz\n\n This applet is a web-based version of our program McBilliards.  Ths purpose of this applet is to let the user explore periodic billiard paths in triangles.  The window you are currently reading is the info window. You scroll the text using the light blue arrow keys above\n\nVarious parts of the applet have little boxes with question marks in them.  If you click on these info boxes, this window will document the corresponding part of the appet. \n\n We already mentioned that you can scroll the text by clicking on the light blue arrow keys.  Here are some other control features of this window:\n \n You can change the scroll amount by clicking on the darker blue arrow keys.\n \n You can change the width of the text by clicking on the red arrow keys.\n \n You can change the font size by clicking on the green arrow keys.");
    }
    
    public void mouseClicked(MouseEvent e) {
        e.consume();
        Point X=new Point();
        X.x=e.getX();
        X.y=e.getY();
        if(L.inside(X)==1) document();
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
}
