package Current.plot.Plotters;

import Current.basic.*;
import Current.manage.*;
import Current.popups.Deg100.*;
import Current.plot.Dyadic.*;

import java.awt.Color;
import java.io.Serializable;
import java.awt.Component;
import java.awt.Canvas;

/**
 * This is the wrapper for the 100 degree result verifier
 * @author  pat; modified by Rich
 */
public class XPoly2Plotter implements XPlotter, Serializable {

    /** Run the algorithm to plot the tile. */
    public Tile plot(String word, Color C, Interrupter I, Manager M) {
        Deg100Verifier DP=new Deg100Verifier(M);
        DyadicTile DT=DP.basicPlot(word);
        if (DT!=null) DT.xp=new XPoly2Plotter();
        return DT;
    }
    
    public Component getController(Manager M){
        return new Canvas();
    }
    
    public String getName() {
        return "poly";
    }
    
    public boolean canRun() {
        return true;
    }
    
//    public HelpDocument document() {
//        return new HelpDocument("Plotting.html");
//    }
    
    public Color getColor() {
        return new Color(255,255,0);
    }
    
}
