package Current.plot.Plotters;

import Current.basic.*;
import Current.manage.*;
import Current.plot.Dyadic.*;

import java.awt.Color;
import java.io.Serializable;
import java.awt.Component;
import java.awt.Canvas;

/**
 * The billiard-like plot needs very little to do a plot.
 *
 * @author  pat
 */
public class XZonePlotter extends XDyadicPlotter implements Serializable {
    /** default constructor */
    public XZonePlotter(){}
    
    /** copy constructor */
    public XZonePlotter(XZonePlotter p) {
        this.detail=p.detail;
        this.show_squares=p.show_squares;
        this.filter=p.filter;
    }
    
    /** Run the algorithm to plot the tile. */
    public Tile plot(String word, Color C, Interrupter I, Manager M) {
        DyadicTile DT=DyadicPlotter.zonePlot(show_squares,word,detail,C,M.getZ(), I);
        if (DT!=null)
            DT.xp=new XZonePlotter(this);
        return DT;
    }
    
    public Component getController(Manager M){
        return new PlottingDyadic(M,this);
    }
    
    public String getName() {
        return "zone";
    }
    
    /** Returns true if the plot can be run. This is useful for example
     * if the plot relies on C code which may or may not be available
     */
    public boolean canRun(){
        return true;
    }
    
    /** This is the color of the button to render */
    public Color getColor() {
        return new Color(50,255,50);
    }
    
//    public HelpDocument document() {
//        return new HelpDocument("PlottingZone.html");
//    }
}
