package Current.popups.AnimatedWord;

import Current.basic.*;
import Current.gui.*;
import Current.manage.*;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;



public class AnimatedWordControlCanvas extends DBCanvas implements MouseListener {
    Manager M;
    AnimatedWordCanvas A;
    AnimatedWordContainer AContainer; 
    ListenSquare[][] CHOICE=new ListenSquare[3][5];
    ListenSquare[] L=new ListenSquare[5];
    IntegerSelector[] I=new IntegerSelector[2];
    int hear;
    int[] UNFOLD=new int[3];


    public AnimatedWordControlCanvas(Manager M, AnimatedWordCanvas A) {
        this.M=M;
        this.A=A;
        addMouseListener(this);
	M.addListener(this);

         for(int i=0;i<=3;++i) {
	       CHOICE[0][i]=new ListenSquare(52,20+15*i,10,10,Color.white); //spine toggle
	       CHOICE[1][i]=new ListenSquare(100,20+15*i,10,10,Color.white); //trace toggle
	       CHOICE[2][i]=new ListenSquare(148,20+15*i,10,10,Color.white); //subword toggle
	 }
               CHOICE[0][0].on=1;
               CHOICE[1][0].on=1;
	       CHOICE[2][0].on=1;

               I[0]=new IntegerSelector(214,45,40,20,0,1,1,1); //manual digits
               I[1]=new IntegerSelector(220,22,28,14,1,-9,9,1); //animation speed
	       L[0]=new ListenSquare(5,90,10,10,Color.white); //background hex
               L[1]=new ListenSquare(5,105,10,10,Color.white); //background grid
	       L[0].on=1;
	       L[2]=new ListenSquare(5,125,10,10,Color.white); //shape
	       L[3]=new ListenSquare(210,90,10,10,Color.white);  //unfold no
	       L[4]=new ListenSquare(210,105,10,10,Color.white);  //unfold yes
	       L[3].on=1;
	       hear=0;

    }

    
    // set this if it is contained in an UnfoldContainer
    public void addAnimatedWordContainer(AnimatedWordContainer UContainer){
        this.AContainer=AContainer;
    }

    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
	g.setColor(new Color(0,0,200));
	g.fillRect(0,0,this.getWidth(),this.getHeight());
	drawChoice(g);
	drawControls(g);

    }


    public void drawControls(Graphics g) {
       g.setColor(new Color(0,0,100));
       g.fillRect(176,2,120,80);
       g.setColor(Color.white);
       g.drawRect(176,2,120,80);

       I[0].render(g,Color.black,Color.white,Color.white);
       I[1].render(g,Color.black,Color.white,Color.white);
       g.setFont(new Font("Helvetica",Font.PLAIN,10));
       g.drawString("animation speed",195,15);
       g.drawString("manual",217,78);


       g.setColor(new Color(0,0,100));
       g.fillRect(2,87,125,52);
       g.setColor(Color.white);
       g.drawRect(2,87,125,52);
       g.drawString("hex background",23,100);
       g.drawString("sqr background",23,115);
       g.drawString("ignore unfold",140,100);   
       g.drawString("hear unfold",140,115);
       if(A.shape==0) g.drawString("hex shape: regular",23,135);
       if(A.shape==1) g.drawString("hex shape: integral",23,135);
       for(int i=0;i<=4;++i) L[i].render(g,new Color(255,0,255));

    }



    public void drawChoice(Graphics g) {
	g.setColor(new Color(0,0,100));
	g.fillRect(2,2,170,80);

	for(int i=0;i<=2;++i) {
	    for(int j=0;j<=3;++j) {
		CHOICE[i][j].render(g,new Color(255,0,255));
	    }
	}
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
	g.drawString("hexpath",5,30);	
        g.drawString("spine1",5,45);	
        g.drawString("spine2",5,60);	
        g.drawString("sqrpath",5,75);
	g.drawString("subword",40,15);
	g.drawString("animate",90,15);
	g.drawString("draw",140,15);
	g.drawRect(2,2,170,80);
    }


	public void setSpeed(Point X) {

	    //manual
	  if(I[0].isModified(X)==1) {
	      I[0].max=A.word.length();
              I[0].modifyCyclic(X);
	      A.A.count=I[0].val;
              A.location=I[0].val;}

          I[1].modify(X);
          A.speed=I[1].val;
          A.A.delay=(int)(Math.pow(2,10-Math.abs(A.speed)));
	}


    /**This is what is received from the unfold window*/

    public void mcbReceive(int[] q) {
	if(hear==1) {
	    UNFOLD[0]=q[0];  //spine number
	    UNFOLD[1]=q[1];  //spine start
	    UNFOLD[2]=q[2];  //spine stop
	    overrideChoices();
	    repaint();
	    A.start=UNFOLD[1]-1;
	    A.stop=UNFOLD[2]-2;
	    A.createBackground();
	    A.repaint();
	    System.out.println("unfold ");
	    System.out.println(UNFOLD[1]+" "+UNFOLD[2]);
	}
    }
    
    public void overrideChoices() {
	for(int i=0;i<=2;++i) {
	    for(int j=0;j<=3;++j) {
		CHOICE[i][j].on=0;
	    }
	}
	for(int i=0;i<=2;++i) {
	CHOICE[i][UNFOLD[0]].on=1;
	}
    }





    public void mouseEntered(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {

        MouseData MD=MouseData.process(M,e);
        int mode=MD.mode;
        Point X=MD.X;  

	setSpeed(X);

	for(int i=0;i<=1;++i) {if(L[i].inside(X)==1) L[i].on=1-L[i].on;}
	if(L[2].inside(X)==1) {A.shape=1-A.shape;A.newWordReceived();}

	for(int j=0;j<=2;++j) {
	    for(int i=0;i<=3;++i) {
		if(CHOICE[j][i].inside(X)==1) CHOICE[j][i].on=1-CHOICE[j][i].on;
	    }
	}

	int test=-1;
	if(L[3].inside(X)==1) test=3;
	if(L[4].inside(X)==1) test=4;
	if(test!=-1) {
	    L[3].on=0;
	    L[4].on=0;
	    L[test].on=1;
	    hear=test-3;
	}


    

	repaint();
	A.createBackground();
	A.repaint();

    }

}
