/*
 * DisplayProperties.java
 *
 * Created on March 10, 2006, 1:42 PM
 */

package Current.popups.BilliardPath;

import java.awt.*;
import java.util.*;
import java.io.*;

import Current.*;
import Current.manage.*;

/**
 * This class stores the settings for both the DisplayConeSurface and DisplayBilliardPath
 * windows.
 *
 * @author  pat
 */
public class DisplayProperties {
    
    public static class ColorSettings implements Serializable {
        
        /** title of these settings */
        public String getTitle() {
            return "billiard path popup colors";
        }
        
        public Color bgColor=Color.GRAY;
        public static final String bgColor_name="background color";
        
        public Color borderColor=Color.black;
        public static final String borderColor_name="border color";

        public Color insideColor1=Color.white;
        public static final String insideColor1_name="triangle #1 color";
        
        public Color insideColor2=Color.white;
        public static final String insideColor2_name="triangle #2 color";
        
        public Color pathColor=Color.blue;
        public static final String pathColor_name="path color";

        public Color textColor=Color.black;
        public static final String textColor_name="text color";
        
    }
    
    private Manager M;

    public ColorSettings colors;
    
    public double pos=0.5; // position inside strip
    
    // show arrows?
    public boolean arrows=true;
    
    // show edge labels?
    public boolean edge_labels=true;
    
    public Stroke
    triangleStroke=new BasicStroke(1),
    pathStroke=new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_BEVEL);
    
    public double rotation_angle=0;
    
    /** Creates a new instance of DisplayProperties */
    public DisplayProperties(Manager M) {
        this.M=M;
        
        colors=(ColorSettings)(M.settings.getDefault(ColorSettings.class));
    }
    
    public void mcbCleanup() {
    }
    
}
