package Current.popups.Help;

import Current.*;

import Current.manage.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import java.net.URL;
import java.util.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.border.EmptyBorder;



/**
 *
 * @author  pat
 */
public class Help extends Container implements HyperlinkListener, ComponentListener {
    
    Manager M;
    
    JEditorPane pane;
    HTMLEditorKit kit;
    StyleSheet ss;
    
    public int font_size=12;
    public int line_scroll=0;
    
    protected int width=320;
    static private int FILE=0;
    static private int STRING=1;
    protected int type=FILE;
    protected String current="about.html";
    
    
    /** Creates a new instance of Help */
    public Help(Manager M, String file) {
        current=file;
        type=FILE;
        init(M);
    }
    
    /** Creates a new instance of Help */
    public Help(Manager M, HelpString hs) {
        current=hs.str;
        type=STRING;
        init(M);
    }
    
    /** Creates a new instance of Help */
    public Help(Manager M) {
        init(M);
    }
    
    private void init(Manager M) {
        this.M=M;
        
        setBackground(new Color(30,144,255));
        //setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
        pane=new JTextPane();
        pane.setEditable(false);
        pane.setDragEnabled(false);
        pane.setDoubleBuffered(false);
        
        pane.setContentType("text/html");
        pane.setMargin(null);
        pane.setBorder(null);
        pane.setBackground(new Color(30,144,255));
        
        pane.addHyperlinkListener(this);
        
        noInteraction();
        reset();
        
        addComponentListener(this);
        add(pane);
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(320,240);
    }
    
    public void noInteraction() {
        {
            MouseListener[] ml=pane.getMouseListeners();
            //System.out.println("num="+ml.length);
            for (int i=0; i<ml.length; i++) {
                pane.removeMouseListener(ml[i]);
            }
        } {
            MouseMotionListener[] ml=pane.getMouseMotionListeners();
            //System.out.println("num="+ml.length);
            for (int i=0; i<ml.length; i++) {
                pane.removeMouseMotionListener(ml[i]);
            }
        } {
            MouseWheelListener[] ml=pane.getMouseWheelListeners();
            //System.out.println("num="+ml.length);
            for (int i=0; i<ml.length; i++) {
                pane.removeMouseWheelListener(ml[i]);
            }
        }
        
    }
    
    public void reset() {
        kit = new HTMLEditorKit();
        ss=kit.getStyleSheet();
        ss.addRule("body {width: "+getWidth()+"pt; font-size:"+font_size+"pt; padding: 5px; margin: 0px; }");
        //ss.addRule("li {width: padding-left: 0px; padding: 0px; margin-left: 5px; }");
        pane.setEditorKit(kit);
        if (type==FILE) {
            setPage(current);
        } else if (type==STRING) {
            setString(current);
        }
    }
    
    //    String page_string;
    //
    //    public void readString(String file) {
    //        InputStreamReader in=new InputStreamReader(M.getInputStream("Files/Help/"+file));
    //        char[] cbuf=new char[256];
    //        int ret;
    //        StringWriter out=new StringWriter();
    //
    //        try {
    //            do {
    //                ret=in.read(cbuf,0, 256);
    //                if (ret!=-1) {
    //                    out.write(cbuf,0,ret);
    //                }
    //            } while(ret != -1);
    //            in.close();
    //            page_string=out.toString();
    //            out.close();
    //        } catch (Throwable T) {
    //            T.printStackTrace();
    //        }
    //    }
    
    /** display the help file.
     * the file should be in the directory Files/Help/ */
    public void setPage(String file) {
        type=FILE;
        if ((width!=getWidth())||(current.compareTo(file)!=0)) {
            line_scroll=0;
            current=file;
            try {
                pane.setPage(M.toURL("Files/Help/"+file));
                //pane.setText(page_string);
            } catch (Throwable T) {
                System.err.println("Failed to load help file: \"Files/Help/"+file+"\"");
                System.err.flush();
                T.printStackTrace();
            }
        }
        resetScroll();
    }
    
    /** display the help file.
     * the file should be in the directory Files/Help/ */
    public void setString(String content) {
        type=STRING;
        if ((width!=getWidth())||(current.compareTo(content)!=0)) {
            line_scroll=0;
            current=content;
            try {
                pane.setText(current);
                //pane.setText(page_string);
            } catch (Throwable T) {
                System.err.println("Failed to setText");
                System.err.flush();
                T.printStackTrace();
            }
        }
        resetScroll();
    }
    
    
    public void resetScroll() {
        Dimension p=pane.getPreferredSize();
        Dimension d=new Dimension(p.width, p.height);
        if (d.height<getHeight()) {
            pane.setLocation(0, 0);
            d.height=getHeight();
            line_scroll=0;
        } else {
            if (line_scroll*font_size+getHeight()>p.height) {
                pane.setLocation(0,getHeight()-p.height);
                line_scroll=(p.height-getHeight()+font_size-1)/font_size;
            } else {
                pane.setLocation(0, -line_scroll*this.font_size);
            }
        }
        pane.setSize(d);
    }
    
    public void hyperlinkUpdate(HyperlinkEvent e) {
        if (e.getEventType()==HyperlinkEvent.EventType.ACTIVATED) {
            //System.out.println(e.getDescription());
            //System.out.println(e.getURL());
            M.mcbSend(new HelpDocument(e.getDescription()));
        }
        //        if (e.getEventType()==HyperlinkEvent.EventType.ACTIVATED) {
        //
        //            try {
        //                SimpleAttributeSet anchor=(SimpleAttributeSet)
        //                (e.getSourceElement().getAttributes().getAttribute(HTML.Tag.A));
        //                String link=(String)(anchor.getAttribute(HTML.Attribute.HREF));
        //                setPage(link);
        //            } catch (Throwable T) {
        //                System.out.println("error following help link");
        //                T.printStackTrace();
        //            }
        //        }
    }
    
    public void componentHidden(ComponentEvent e) {
    }
    
    public void componentMoved(ComponentEvent e) {
    }
    
    public void componentResized(ComponentEvent e) {
        reset();
        
        //System.out.println("this size="+getSize());
        //System.out.println("size="+pane.getSize());
        //System.out.println("prefered size="+pane.getPreferredSize());
        //System.out.println("prefered scroll size="+pane.getPreferredScrollableViewportSize());
    }
    
    public void componentShown(ComponentEvent e) {
        //setSize(300,300);
        reset();
    }
    
    
}
