/*
 * ImageSavePopup.java
 *
 * Created on March 8, 2006, 1:31 PM
 */

package Current.popups.ImageSave;

import Current.gui.*;
import Current.manage.*;
import Current.util.TextProcess;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
import java.io.File;
import org.freehep.graphics2d.VectorGraphics;
import org.freehep.graphicsio.ps.PSGraphics2D;
import org.freehep.graphicsio.svg.SVGGraphics2D;

import org.pat.graphics.boxed.ListenString;

/**
 *
 *
 * @author  pat
 */
public class ImageSavePopup extends Container {
    public static boolean canSave(){
        SecurityManager SM=System.getSecurityManager();
        if (SM==null) {
            //System.out.println("No SecurityManager Present!");
            return true;
        }
        return false;
    }
    
    Manager M;
    static final int padding=4;
    static Color bgColor=new Color(0,110,146);
    
    Title T;
    private int mode=0;
    SaverList L;
    SaveOptions O;
    String select=null;
    
    public ImageSavePopup(Manager M) {
        setBackground(Color.BLUE);
        this.M=M;
        setLayout(new BorderLayout());
        T=new Title();
        add(T,"North");
        L=new SaverList();
        add(L,"Center");
        setSize(200,200);
    }
    
    public void cleanup() {
        if (L!=null) {
            L.cleanup();
        }
    }
    
    public void toggle(){
        invalidate();
        switch (mode){
            case 0:
                remove(L);
                L.cleanup();
                L=null;
                break;
            case 1:
                remove(O);
                O=null;
                break;
        }
        mode=(mode+1)%2;
        switch (mode){
            case 0:
                L=new SaverList();
                add(L,"Center");
                break;
            case 1:
                O=new SaveOptions();
                add(O,"Center");
                break;
        }
        T.LS[0].str=T.info[mode];
        validate();
        //repaint();
    }
    
    public class Title extends Canvas implements MouseListener {
        private ListenString[] LS=new ListenString[3];
        private String[] info={"choose canvas:", "choose file:"};
        
        public Title() {
            setFont(new Font("sanserif", Font.PLAIN, 12));
            setBackground(bgColor);
            
            LS[2]=new ListenString("save an image",this);
            LS[2].showBorder=false;
            LS[2].setLeft(padding);
            LS[2].setTop(padding);
            LS[2].setColors(Color.WHITE, bgColor);
            
            LS[0]=new ListenString(info[mode],info,this);
            LS[0].showBorder=false;
            LS[0].setLeft(padding);
            LS[0].setTop(LS[2].getBottom()+2*padding);
            LS[0].setColors(Color.WHITE, bgColor);
            
            LS[1]=new ListenString("?",this);
            LS[1].setTop(padding);
            LS[1].setColors(Color.WHITE, bgColor);
            
            setSize((int)(LS[1].getRight()+padding),
            (int)(LS[0].getBottom()+padding));
            
            addMouseListener(this);
        }
        
        
        public void paint(Graphics gfx) {
            Graphics2D g=(Graphics2D) gfx;
            
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            LS[1].setRight(getWidth()-padding);
            
            for (int i=0; i<LS.length; i++) {
                LS[i].render(g);
            }
        }
        
        public void mouseClicked(java.awt.event.MouseEvent e) {
            if (LS[1].contains(e.getX(), e.getY())){
                M.mcbSend(new HelpDocument("ImageSavePopup.html"));
                //M.setExplain("This popup allows you two save an image file in McBilliards. First, select the canvas whose image you would like to save. On the next page you can choose a file name and an extention. Select \".eps\" to save an encapulated postscript file and \".svg\" to save a scalable vector graphics file. Then click save. The file will appear in the main directory of McBilliards.");
                return;
            }
        }
        
        public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
        }
        
        public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
        }
        
        public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
        }
        
        public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
        }
        
    }
    
    
    
    public class SaverList extends StringListCanvas implements ImageSaveManager.ImageSaveListener {
        
        /** Creates a new instance of ImageSavePopup */
        public SaverList() {
            setColors(new Color(0,50,100), new Color(100,100,255), Color.yellow, Color.black);
            setNames(M.ISM.getTitles());
            setSize(200,150);
            M.ISM.hear(this);
        }
        
        public void cleanup() {
            M.ISM.dontHear(this);
        }
        
        public void deselect() {
        }
        
        public void select(String str) {
            select=str;
            toggle();
        }
        
        public void imageSaveListChanged() {
            setNames(M.ISM.getTitles());
            repaint();
        }
        
    }
    
    public class SaveOptions extends Canvas implements MouseListener, FocusListener, KeyListener {
        private ListenString[] LS=new ListenString[8];
        String[] extensions={".eps",".svg"};
        int ext=0;
        boolean selected=false;
        
        Color bgColor=new Color(0,50,100);
        
        public SaveOptions() {
            setFont(new Font("sanserif", Font.PLAIN, 12));
            setBackground(bgColor);
            
            LS[0]=new ListenString("canvas: ",this);
            LS[0].showBorder=false;
            LS[0].setLeft(padding);
            LS[0].setTop(padding);
            LS[0].setColors(Color.WHITE, bgColor);
            
            LS[1]=new ListenString(select,this);
            LS[1].showBorder=false;
            LS[1].setLeft(padding+LS[0].getRight());
            LS[1].setTop(padding);
            LS[1].setColors(Color.WHITE, bgColor);
            
            LS[2]=new ListenString("filename: ",this);
            LS[2].showBorder=false;
            LS[2].setLeft(padding);
            LS[2].setTop(3*padding+LS[0].getBottom());
            LS[2].setColors(Color.WHITE, bgColor);
            
            LS[3]=new ListenString("",this);
            LS[3].setLeft(padding);
            LS[3].setTop(padding+LS[2].getBottom());
            LS[3].setColors(Color.BLACK, Color.WHITE);
            
            LS[4]=new ListenString("output",this);
            LS[4].setLeft(padding);
            LS[4].setTop(padding+LS[2].getBottom());
            LS[4].setColors(Color.BLACK, Color.WHITE);
            
            LS[5]=new ListenString(extensions[ext],extensions,this);
            LS[5].setTop(padding+LS[2].getBottom());
            LS[5].setColors(Color.BLACK, Color.WHITE);
            fixFilename();
            
            LS[6]=new ListenString("save",this);
            LS[6].setLeft(padding);
            LS[6].setTop(LS[5].getBottom()+3*padding);
            LS[6].setColors(Color.WHITE, bgColor);
            
            LS[7]=new ListenString("cancel",this);
            LS[7].setLeft(LS[6].getRight()+2*padding);
            LS[7].setTop(LS[5].getBottom()+3*padding);
            LS[7].setColors(Color.WHITE, bgColor);
            
            LS[3]=null;
            
            addMouseListener(this);
            addFocusListener(this);
            addKeyListener(this);
            
        }
        
        public void fixFilename(){
            //LS[4].setLeft(LS[3].getRight()+1);
            LS[5].setLeft(LS[4].getRight()+1);
        }
        
        public void paint(Graphics gfx) {
            Graphics2D g=(Graphics2D) gfx;
            
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            fixFilename();
            
            for (int i=0; i<LS.length; i++) {
                if (LS[i]!=null)
                    LS[i].render(g);
            }
        }
        
        public void selectColors() {
            if (! selected) {
                LS[4].setColors(Color.black,Color.white);
            } else {
                LS[4].setColors(Color.white,Color.black);
            }
        }
        
        public void save() {
            try {
                ImageSaver is=M.ISM.get(select);
                
                Properties p = new Properties();
                
                VectorGraphics g=null;
                
                File F=new File(""+LS[4].str+extensions[ext]);
                Dimension D= new Dimension(is.getWidth(),is.getHeight());
                //p.setProperty("PageSize","A5");
                
                if (extensions[ext]==".eps") {
                    g = new PSGraphics2D(F,D);
                    p.setProperty(
                    PSGraphics2D.ORIENTATION,
                    "Portrait");
                } else if (extensions[ext]==".svg") {
                    g = new SVGGraphics2D(F,D);
                }
                g.setProperties(p);
                g.startExport();
                g.setClip(0,0, is.getWidth(), is.getHeight());
                if (is.getBackground().equals(Color.white)) {
                    g.setColor(is.getBackground());
                    g.fillRect(0,0, is.getWidth(), is.getHeight());
                }
                is.imageSave(g);
                g.endExport();
            } catch (Throwable t) {
                t.printStackTrace();
            }
        }
        
        public void deselect(){
            if (selected) {
                selected=false;
                selectColors();
            }
        }
        
        public void mouseClicked(MouseEvent e) {
            if (LS[4].contains(e.getX(), e.getY())) {
                selected=!selected;
                selectColors();
                repaint();
                return;
            }
            if (LS[6].contains(e.getX(), e.getY())) {
                save();
                toggle();
                return;
            }
            if (LS[7].contains(e.getX(), e.getY())) {
                toggle();
                return;
            }
            if (LS[5].contains(e.getX(), e.getY())) {
                ext=(ext+1)%extensions.length;
                LS[5].str=extensions[ext];
                deselect();
                repaint();
                return;
            }
            if (selected) {
                deselect();
                repaint();
                return;
            }
        }
        
        public void mouseEntered(MouseEvent e) {
        }
        
        public void mouseExited(MouseEvent e) {
        }
        
        public void mousePressed(MouseEvent e) {
        }
        
        public void mouseReleased(MouseEvent e) {
        }
        
        public void keyPressed(java.awt.event.KeyEvent keyEvent) {
        }
        
        public void keyReleased(java.awt.event.KeyEvent keyEvent) {
        }
        
        public void keyTyped(KeyEvent e) {
            if (e.getKeyChar()==KeyEvent.VK_TAB) {
                if (!selected) {
                    selected=true;
                    selectColors();
                    repaint();
                }
                return;
            }
            if (selected) {
                String temp=TextProcess.Filename(LS[4].str, e);
                if (temp.length()>12) {
                    temp=temp.substring(0,12);
                }
                if (! LS[4].str.equals(temp)) {
                    LS[4].str=temp;
                    LS[4].size();
                    repaint();
                    return;
                }
            }
            
        }
        
        public void focusGained(java.awt.event.FocusEvent focusEvent) {
        }
        
        public void focusLost(java.awt.event.FocusEvent focusEvent) {
            if (selected) {
                selected=false;
                selectColors();
                repaint();
                return;
            }
        }
        
    }
}
