/*
 * TileMemorySave.java
 *
 * Created on June 8, 2006, 10:50 PM
 */

package Current.popups.Memory;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Line2D;

import org.pat.graphics.boxed.ListenString;

import Current.manage.*;
import Current.util.TextProcess;

/**
 *
 * @author  pat
 */
public class TileMemorySaveCanvas extends Canvas implements MouseListener, FocusListener, KeyListener {
    public class Success extends Canvas {
        ListenString LS;
        
        public Success() {
            setFont(new Font("sanserif", Font.PLAIN, 12));
            setBackground(TileMemorySaveCanvas.this.getBackground());
            
            LS=new ListenString("Saved current tiles to file:",this);
            LS.setLeft(4);
            LS.setTop(4);
            LS.showBorder=false;
            LS.setColors(fgColor, getBackground());
            filename.setTop(4+LS.getBottom());
        }
        
        public void paint(Graphics gfx) {
            Graphics2D g=(Graphics2D) gfx;
            
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            LS.render(g);
            filename.render(g);
        }
    }

    Manager M;
    TileMemoryContainer cont;
    
    boolean selected=false;
    
    ListenString[]
    comments=new ListenString[3],
    options=new ListenString[3];
    
    ListenString filename,save;
    
    
    public static Color
    fgColor=Color.black, //new Color(68,77,97),
    buttonBg=new Color(231,206,143);
    
    public final static int padding=4;
    
    public static final String[] yesorno={"yes","no"};
    
    /** Creates a new instance of TileMemorySave */
    public TileMemorySaveCanvas(TileMemoryContainer cont) {
        this.M=cont.M;
        this.cont=cont;
        
        setFont(new Font("sanserif", Font.PLAIN, 12));
        setBackground(new Color(222,144,60));
        comments[0]=new ListenString("Save Tiles", this);
        comments[1]=new ListenString("filename:", this);
        options[0]=new ListenString("MMMMMMMMMMMM", this);
        comments[2]=new ListenString("save tile types", this);
        options[1]=new ListenString("yes", yesorno, this);
        options[2]=new ListenString("save", this);
        
        for (int i=0; i<comments.length; i++) {
            comments[i].setColors(fgColor, getBackground());
            comments[i].showBorder=false;
        }
        for (int i=0; i<options.length; i++) {
            options[i].setColors(fgColor, buttonBg);
            //options[i].showBorder=false;
        }
        
        double x=padding, y=padding;
        comments[0].setTop(y);
        
        y=comments[0].getBottom()+3*padding;
        comments[1].setLeft(x);
        comments[1].setTop(y);
        
        y=comments[1].getBottom()+padding;
        options[0].setLeft(x);
        options[0].setTop(y);
        
        y=options[0].getBottom()+3*padding;
        comments[2].setLeft(x);
        comments[2].setTop(y);
        
        x=comments[2].getRight()+padding;
        options[1].setTop(y);
        
        x=padding;
        y=options[1].getBottom()+3*padding;
        options[2].setTop(y);
        
        
        filename=options[0];
        save=options[2];
        
        filename.str="filename";
        
        addMouseListener(this);
        addFocusListener(this);
        addKeyListener(this);
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(200,200);
    }
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        
        comments[0].setHorizontalCenter(getWidth()/2);;
        options[1].setRight(getWidth()-padding);
        save.setHorizontalCenter(getWidth()/2);;
        
        for (int i=0; i<comments.length; i++) {
            comments[i].render(g);
        }for (int i=0; i<options.length; i++) {
            options[i].render(g);
        }
        
        float[] dash={1.0f,3.0f};
        g.setStroke(new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,
        1,dash,1));
        g.draw(new Line2D.Double(
        comments[2].getRight(),
        comments[2].getBottom(),
        options[1].getLeft()-padding,
        options[1].getBottom()));
        
    }
    
    public void selectColors() {
        if (! selected) {
            filename.setColors(fgColor, buttonBg);
        } else {
            filename.setColors(Color.black,Color.white);
        }
    }
    
    private void save() {
        if (filename.str.length()!=0) {
            try {
                if (options[1].str.compareTo("yes")!=0) {
                    TileMemory.saveWordsAndColors(filename.str, M.STM.getTiles());
                } else {
                    TileMemory.saveConstructors(filename.str, M.STM.getTiles());
                }
            } catch (Throwable t) {
                System.out.println("Error saving tiles");
                t.printStackTrace();
            }
            cont.setCenter(new Success());
        }
    }
    
    public void mouseClicked(MouseEvent e) {
        if (filename.contains(e)) {
            selected=!selected;
            selectColors();
            repaint();
            return;
        }
        if (save.contains(e)) {
            save();
        }
        if (selected) {
            selected=!selected;
            selectColors();
            repaint();
            return;
        }
        ListenString yn=options[1];
        if (yn.contains(e)) {
            if (yn.str.compareTo("yes")==0) {
                yn.str="no";
            } else {
                yn.str="yes";
            }
            repaint();
            return;
        }
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void keyPressed(java.awt.event.KeyEvent keyEvent) {
    }
    
    public void keyReleased(java.awt.event.KeyEvent keyEvent) {
    }
    
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar()==KeyEvent.VK_TAB) {
            if (!selected) {
                selected=true;
                selectColors();
                repaint();
            }
            return;
        }
        if (selected) {
            String temp=TextProcess.Filename(filename.str, e);
            if (temp.length()>12) {
                temp=temp.substring(0,12);
            }
            if (! filename.str.equals(temp)) {
                filename.str=temp;
                repaint();
                return;
            }
        }
        
    }
    
    public void focusGained(java.awt.event.FocusEvent focusEvent) {
    }
    
    public void focusLost(java.awt.event.FocusEvent focusEvent) {
        if (selected) {
            selected=false;
            selectColors();
            repaint();
            return;
        }
    }
    
}
