/*
 * TileTitleCanvas.java
 *
 * Created on June 9, 2006, 4:38 PM
 */

package Current.popups.Memory;

import java.awt.*;
import java.awt.event.*;

import org.pat.graphics.boxed.ListenString;
import Current.*;
import Current.manage.*;

/**
 *
 * @author  pat
 */
public class TileTitleCanvas extends Canvas implements MouseListener {
    ListenString[] LS=new ListenString[4];
    TileMemoryContainer cont;
    protected int selected=-1;
    
    /** Creates a new instance of TileTitleCanvas */
    public TileTitleCanvas(TileMemoryContainer cont) {
        this.cont=cont;
        
        setFont(new Font("sanserif", Font.PLAIN, 12));
        setBackground(new Color(99,90,27));
        
        LS[0]=new ListenString("?",this);
        LS[1]=new ListenString("save",this);
        LS[2]=new ListenString("load",this);
        LS[3]=new ListenString("queue",this);
        
        double x=4;
        for (int i=1; i<LS.length; i++) {
            LS[i].setLeft(x);
            x=LS[i].getRight()+4;
        }
        
        for (int i=0; i<LS.length; i++) {
            LS[i].setTop(4);
            LS[i].setColors(new Color(245,211,0), getBackground());
        }
        
        setSelected(1);
        
        addMouseListener(this);
    }
    public void setSelected(int i) {
        if ((selected>0)) {
            LS[selected].setColors(new Color(245,211,0), getBackground());
        }
        selected=i;
        if ((selected>0)) {
            LS[selected].setColors(new Color(245,211,0), new Color(39,108,95));
        }
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(
        (int)(LS[LS.length-1].getRight()+LS[0].getWidth()+8),
        (int)(LS[0].getBottom()+4));
    }
    
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        
        LS[0].setRight(getWidth()-4);
        for (int i=0; i<LS.length; i++) {
            if ((i!=1)||(cont.M.canWrite()))
                LS[i].render(g);
        }
    }
    
    public void mouseClicked(MouseEvent e) {
        if ((cont.M.canWrite())&&(LS[1].contains(e))) {
            cont.setCenter(new TileMemorySaveCanvas(cont));
            return;
        }
        if (LS[2].contains(e)) {
            cont.setCenter(new TileMemoryLoadCanvas(cont));
            return;
        }
        if (LS[3].contains(e)) {
            cont.setCenter(new TilePlotQueueCanvas(cont));
            return;
        }
        if (LS[0].contains(e)) {
            cont.M.mcbSend(new HelpDocument("TileMemory.html"));
        }
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
}
