/*
 * AutGp.java
 *
 * Created on December 3, 2006, 12:02 PM
 */

package Current.popups.Nearby;

import java.util.LinkedList;
import java.util.ListIterator;

/**
 *
 * @author  pat
 */
public class AutGp  extends NearbySaddle {
    
    public class Segment {
        private int e;
        
        public Segment(boolean top, boolean forward, int edge) {
            e=2*(edge-1);
            if (! top)
                e+=1;
            if (! forward)
                e+=2;
        }
        
        public boolean top() {
            return (e%2==0);
        }
        
        public boolean forward() {
            if (e<0)
                return ((e-1)/2)%2==0;
            else
                return (e/2)%2==0;
        }
        
        public int edge(){
            if (e<0)
                return 2*((e-3)/4)+1;
            else
                return 2*(e/4)+1;
        }
        
        public boolean isNeg(Segment s) {
            return ((edge()==s.edge())&&(!(top() ^ s.top()))&&(forward() ^ s.forward()));
        }
        
        public String toString() {
            String s=new String();
            if (! forward()) {
                s+="-";
            }
            s+="(";
            s+=edge();
            s+=")";
            if (!top()) {
                s+="v";
            } else {
                s+="^";
            }
            return s;
        }
    }
    
    LinkedList word=new LinkedList();
    
    public void add(Segment s) {
        if (word.size()>0) {
            if (((Segment)(word.getLast())).isNeg(s)) {
                //System.out.println("Eliminating pair "+s+" and "+(Segment)(word.getLast()));
                word.removeLast();
                return;
            }
        }
        word.addLast(s);
    }
    
    public void unconjugate() {
        while (word.size()>0) {
            if (((Segment)(word.getLast())).isNeg((Segment)(word.getFirst()))) {
                word.removeLast();
                word.removeFirst();
            } else {
                return;
            }
        }
    }
    
    /** n should be a positive integer */
    public AutGp(boolean even, int n) {
        word=new LinkedList();
        if (even) { // slope zero
            int i;
            for (i=-(2*n-1); i<=2*n-1; i+=2) {
                word.add(new Segment(true,true,i));
            }
            for (i=2*n-1; i>=-(2*n-1); i-=2) {
                word.add(new Segment(false,true,i));
            }
        } else { // slope 1
            int i;
            for (i=-(2*n-3); i<=2*n-1; i+=2) {
                word.add(new Segment(true,true,i));
            }
            for (i=2*n-1; i>=-(2*n-3); i-=2) {
                word.add(new Segment(false,true,i));
            }
        }
    }
    
    public AutGp(AutGp A, int g) {
        if (g==0) {
            Segment s;
            for (ListIterator it=A.word.listIterator();it.hasNext();) {
                s=(Segment)(it.next());
                add(new Segment(s.top(),!s.forward(),-s.edge()));
            }
        }
        if (g==1) {
            Segment s;
            for (ListIterator it=A.word.listIterator();it.hasNext();) {
                s=(Segment)(it.next());
                add(new Segment(s.top(), !s.forward(), 2-s.edge()));
            }
        }
        if (g==2) {
            //boolean odd=true;
            Segment s;
            for (ListIterator it=A.word.listIterator();it.hasNext();) {
                s=(Segment)(it.next());
                if (s.forward()) {
                    if (s.edge()>0) {
                        if (s.top()) {
                            for (int i=s.edge()-2; i>=-(s.edge()-2); i-=2)
                                add(new Segment(false, true, i));
                            for (int i=-(s.edge()-2); i<=s.edge(); i+=2)
                                add(new Segment(true, true, i));
                        } else {
                            for (int i=s.edge(); i>=-(s.edge()-2); i-=2)
                                add(new Segment(false, true, i));
                            for (int i=-(s.edge()-2); i<=s.edge()-2; i+=2)
                                add(new Segment(true, true, i));
                        }
                    } else {
                        if (s.top()) {
                            for (int i=s.edge(); i<=-s.edge(); i+=2)
                                add(new Segment(false, false, i));
                            for (int i=-s.edge(); i>=s.edge()+2; i-=2)
                                add(new Segment(true, false, i));
                        } else {
                            for (int i=s.edge()+2; i<=-s.edge(); i+=2)
                                add(new Segment(false, false, i));
                            for (int i=-s.edge(); i>=s.edge(); i-=2)
                                add(new Segment(true, false, i));
                        }
                    }
                } else {
                    if (s.edge()>0) {
                        if (s.top()) {
                            for (int i=s.edge(); i>=-(s.edge()-2); i-=2)
                                add(new Segment(true, false, i));
                            for (int i=-(s.edge()-2); i<=s.edge()-2; i+=2)
                                add(new Segment(false, false, i));
                        } else {
                            for (int i=s.edge()-2; i>=-(s.edge()-2); i-=2)
                                add(new Segment(true, false, i));
                            for (int i=-(s.edge()-2); i<=s.edge(); i+=2)
                                add(new Segment(false, false, i));
                        }
                    } else {
                        if (s.top()) {
                            for (int i=s.edge()+2; i<=-s.edge(); i+=2)
                                add(new Segment(true, true, i));
                            for (int i=-s.edge(); i>=s.edge(); i-=2)
                                add(new Segment(false, true, i));
                        } else {
                            for (int i=s.edge(); i<=-s.edge(); i+=2)
                                add(new Segment(true, true, i));
                            for (int i=-s.edge(); i>=s.edge()+2; i-=2)
                                add(new Segment(false, true, i));
                        }
                    }
                }
            }
            //odd=!odd;
        }
        unconjugate();
    }
    
    /** Creates a new instance of AutGp */
    static AutGp slope(int p, int q, int n) {
        Congruence2 cong=new Congruence2(p,q);
        //System.out.println(cong);
        AutGp A=null;
        if ((p%2==0)&&((q-1)%2==0)) { // cong to 0/1
            A=new AutGp(true,n);
        }
        if (((p-1)%2==0)&&((q-1)%2==0)) { // cong to 1/1
            A=new AutGp(false,n);
        }
        if (A==null) {
            return null;
        }
        Congruence2.Generator g;
        for (ListIterator it=cong.getLL().listIterator(cong.getLL().size());it.hasPrevious();) {
            //System.out.println(A);
            g=(Congruence2.Generator)(it.previous());
            A=new AutGp(A, g.get());
        }
        return A;
    }
    
    public String toString() {
        StringBuffer sb=new StringBuffer();
        Segment s;
        for (ListIterator it=word.listIterator();it.hasNext();) {
            s=(Segment)(it.next());
            sb.append(s);
            sb.append(' ');
        }
        return sb.toString();
    }
    
    public String buildWord(String saddle, String above, String below) {
        StringBuffer sb=new StringBuffer();
        Segment s;
        for (ListIterator it=word.listIterator();it.hasNext();) {
            s=(Segment)(it.next());
            if (s.top()) {
                sb.append(above);
            } else {
                sb.append(below);
            }
            sb.append(saddle);
        }
        return sb.toString();
    }
    
    public String buildWord(String[] saddle, String[] above, String[] below) {
        StringBuffer sb=new StringBuffer();
        Segment s;
        int i=0;
        for (ListIterator it=word.listIterator();it.hasNext();) {
            s=(Segment)(it.next());
            if (s.top()) {
                sb.append(above[i]);
            } else {
                sb.append(below[i]);
            }
            sb.append(saddle[i]);
            i=(i+1)%2;
        }
        return sb.toString();
    }
    
    public String buildWord(NearbySaddle ns) {
        if (ns.crosses) {
            StringBuffer sb=new StringBuffer();
            Segment s,prev;
            int i=0;
            prev=(Segment)(word.getLast());
            for (ListIterator it=word.listIterator();it.hasNext();) {                
                s=(Segment)(it.next());
                if (s.top() ^ prev.top()) {
                    sb.append(ns.cross);
                }                
                if (s.top()) {
                    sb.append(ns.above[i]);
                } else {
                    sb.append(ns.below[i]);
                }
                //sb.append(ns.saddle[i]);
                i=(i+1)%2;
                prev=s;
            }
            return sb.toString();            
        } else {
            StringBuffer sb=new StringBuffer();
            Segment s;
            int i=0;
            for (ListIterator it=word.listIterator();it.hasNext();) {
                s=(Segment)(it.next());
                if (s.top()) {
                    sb.append(ns.above[i]);
                } else {
                    sb.append(ns.below[i]);
                }
                sb.append(ns.saddle[i]);
                i=(i+1)%2;
            }
            return sb.toString();            
        }
    }
    
    public static void main(String[] args) {
        String[] saddle={"3","3"},
        above={"12","21"},
        below={"21","12"};
        for (int i=1; i<=3; i++) {
            System.out.println(slope(1,1, i).buildWord(saddle,above,below));
        }
    }
}
