/*
 * Congruence2.java
 *
 * Created on December 2, 2006, 9:04 PM
 */

package Current.popups.Nearby;

import java.util.LinkedList;
import java.util.ListIterator;

/**
 *
 * @author  pat
 */
public class Congruence2 {
    
    private LinkedList word;
    
    /** This class represents generators for \Gamma_2, a congruence subgroup of
     * SL(2,Z). A value of 0 represents reflection in the hyperbolic geodesic in
     * the upper half plane joining 0 to \infty. 1 represents reflection in
     * 1 \infty. 2 represents reflection in 0 1.
     */
    public class Generator {
        private int g;
        
        public Generator(int g) {
            this.g=g;
        }
        
        public int get() {
            return g;
        }
    }
    
    /** Constructs the word which takes the triangle 0,1,\infty to a
     * triangle with a vertex of p/q.
     */
    public Congruence2(int p, int q) {        
        word=new LinkedList();
        while ( (p!=q) && (p!=0) && (q!=0) ) {
            if (q<0) {
                q=-q;
                p=-p;
            }            
            
            if (p<0) { // p/q<0
                p=-p;
                word.addLast(new Generator(0));
            } else if (p>q) { // p/q>1
                p=2*q-p;
                word.addLast(new Generator(1));
            } else { // p/q in interval (0,1)
                q=2*p-q;
                word.addLast(new Generator(2));
            }
        }
     }
    
    public LinkedList getLL() {
        return word;
    }
    
    public String toString() {
        StringBuffer sb=new StringBuffer();
        Generator g;
        for (ListIterator it=word.listIterator();it.hasNext();) {
            g=(Generator)(it.next());
            sb.append(g.get());
            sb.append(' ');
        }
        return sb.toString();
    }
}
