/*
 * Nearby.java
 *
 * Created on December 3, 2006, 4:50 PM
 */

package Current.popups.Nearby;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.BoxLayout;

import org.pat.graphics.boxed.ListenString;

import Current.gui.*;
import Current.basic.*;
import Current.manage.*;
import Current.manage.ParameterSpace.*;
import Current.util.TextProcess;
import Current.search.*;

/**
 *
 * @author  pat
 */
public class Nearby extends Canvas implements MouseListener, KeyListener, FocusListener {
    ListenString[] LS=new ListenString[17];
    
    final static Color buttonBg=new Color(179,197,197),
    buttonFg=Color.black,
    selectedBg=new Color(196,189,142),
    selectedFg=Color.black,
    background=new Color(233,224,170);
    
    final static int padding=4;
    
    int selected=-1;
    
    Manager M;
    /** Creates a new instance of Nearby */
    public Nearby(Manager M) {
        this.M=M;
        
        setBackground(background);
        setFont(new Font("sanserif", Font.PLAIN, 12));
        
        double x=padding,y=padding;
        
        LS[16]=new ListenString("?", this);
        LS[16].setColors(buttonFg,background);
        LS[16].setTop(padding);
       
        LS[15]=new ListenString("acute", new String[] {"obtuse","acute"}, this);
        LS[15].setLeft(x);
        LS[15].setTop(y);
        LS[15].setColors(Color.white,Color.red);
        //LS[15].showBorder=false;
        y=LS[15].getBottom()+padding;
        
        LS[11]=new ListenString("Slope", this);
        LS[11].setLeft(x);
        LS[11].setTop(y);
        LS[11].setColors(buttonFg,background);
        LS[11].showBorder=false;
        y=LS[11].getBottom()+1;
        
        LS[12]=new ListenString("Rational (odd over odd)", this);
        LS[12].setLeft(x);
        LS[12].setTop(y);
        LS[12].setColors(buttonFg,background);
        LS[12].showBorder=false;
        y=LS[12].getBottom()+1;
        
        for (int i=4; i<6; i++) {
            LS[i]=new ListenString("999999", this);
            LS[i].setLeft(x);
            LS[i].setTop(y);
            LS[i].setColors(buttonFg,buttonBg);
            LS[i].showBorder=false;
            y=LS[i].getBottom()+3;
        }
        y+=padding;
        LS[4].str="1";
        LS[5].str="1";
        y+=padding;
        
        LS[14]=new ListenString("Infintesimal Slope", this);
        LS[14].setLeft(x);
        LS[14].setTop(y);
        LS[14].setColors(buttonFg,background);
        LS[14].showBorder=false;
        y=LS[14].getBottom()+1;
        
        LS[6]=new ListenString("rational", this);
        LS[6].setLeft(x);
        LS[6].setTop(y);
        LS[6].setColors(buttonFg,background);
        LS[6].showBorder=false;
        y=LS[6].getBottom()+1;
        
        LS[7]=new ListenString("denominator not even", this);
        LS[7].setLeft(x);
        LS[7].setTop(y);
        LS[7].setColors(buttonFg,background);
        LS[7].showBorder=false;
        y=LS[7].getBottom()+1;
        
        for (int i=0; i<2; i++) {
            LS[i]=new ListenString("999999", this);
            LS[i].setLeft(x);
            LS[i].setTop(y);
            LS[i].setColors(buttonFg,buttonBg);
            LS[i].showBorder=false;
            y=LS[i].getBottom()+3;
        }
        y+=padding;
        LS[0].str="1";
        LS[1].str="1";
        
        LS[8]=new ListenString("Number of Cylinders", this);
        LS[8].setLeft(x);
        LS[8].setTop(y);
        LS[8].setColors(buttonFg,background);
        LS[8].showBorder=false;
        y=LS[8].getBottom()+1;
        
        LS[9]=new ListenString("From ", this);
        LS[9].setLeft(x);
        LS[9].setTop(y);
        LS[9].setColors(buttonFg,background);
        LS[9].showBorder=false;
        x=LS[9].getRight()+padding;
        
        LS[2]=new ListenString("999", this);
        LS[2].setLeft(x);
        LS[2].setTop(y);
        LS[2].setColors(buttonFg,buttonBg);
        //LS[2].showBorder=false;
        x=padding;
        y=LS[2].getBottom()+1;
        LS[2].str="1";
        
        LS[10]=new ListenString("To ", this);
        LS[10].setLeft(x);
        LS[10].setTop(y);
        LS[10].setColors(buttonFg,background);
        LS[10].showBorder=false;
        x=LS[10].getRight()+padding;
        
        LS[3]=new ListenString("999", this);
        LS[3].setLeft(x);
        LS[3].setTop(y);
        LS[3].setColors(buttonFg,buttonBg);
        //LS[2].showBorder=false;
        x=padding;
        y=LS[3].getBottom()+1;
        LS[3].str="1";
        
        y+=padding;
        
        LS[13]=new ListenString("send", this);
        LS[13].setLeft(x);
        LS[13].setTop(y);
        LS[13].setColors(buttonFg,buttonBg);
        //LS[2].showBorder=false;
        
        addMouseListener(this);
        addKeyListener(this);
        addFocusListener(this);
        setSize();
    }
    
    public void setSize(){
        int x=0,y=0,temp;
        for (int i=0; i<LS.length; i++){
            temp=(int)(LS[i].getRight());
            if (temp>x)
                x=temp;
            temp=(int)(LS[i].getBottom());
            if (temp>y)
                y=temp;
        }
        //temp=(int)(doc.getRight());
        //if (temp>x)
        //    x=temp;
        setSize(x+padding,y+padding);
    }
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        
        LS[16].setRight(getWidth()-padding);
        
        for (int i=0; i<LS.length; i++) {
            if (selected==i) {
                LS[i].setColors(selectedFg,selectedBg);
                LS[i].render(g);
                LS[i].setColors(buttonFg,buttonBg);
            } else {
                LS[i].render(g);
            }
        }
        
        g.setColor(Color.black);
        g.setStroke(new BasicStroke(3));
        g.draw(new Line2D.Double(
        LS[0].getLeft()+3,LS[0].getBottom()+2,
        LS[0].getRight()-3,LS[0].getBottom()+2));
        g.draw(new Line2D.Double(
        LS[4].getLeft()+3,LS[4].getBottom()+2,
        LS[4].getRight()-3,LS[4].getBottom()+2));
    }
    
    public void mouseClicked(MouseEvent e) {        
        //if (! this.hasFocus()) {
        //    this.requestFocus();
        //}
        for (int i=0; i<6; i++) {
            if (LS[i].contains(e.getX(),e.getY())){
                if (selected==i) {
                    selected=-1;
                    repaint();
                } else {
                    if (hasFocus()) {
                        selected=i;
                    }
                    repaint();
                }
                return;
            }
        }
        if (LS[16].contains(e.getX(),e.getY())) {
            M.mcbSend(new HelpDocument("Nearby.html"));
        }
        if (LS[15].contains(e.getX(),e.getY())) {
            if (LS[15].str.compareTo("obtuse")==0) {
                LS[15].str="acute";
            } else {
                LS[15].str="obtuse";
            }
            repaint();
        }
        if (LS[13].contains(e.getX(),e.getY())) {            
            int 
            p=Integer.parseInt(LS[0].str),
            q=Integer.parseInt(LS[1].str),
            a=Integer.parseInt(LS[2].str),
            b=Integer.parseInt(LS[3].str),
            r=Integer.parseInt(LS[4].str),
            s=Integer.parseInt(LS[5].str);
            
            while ((BasicMath.gcd(r,s)!=1)||(r%2==0)||(s%2==0)) {                
                if (BasicMath.gcd(r,s)!=1) {
                    int g=BasicMath.gcd(r,s);                
                    r=r/g;
                    s=s/g;
                }
                if (r%2==0) {
                    r+=1;
                }
                if (s%2==0) {
                    s+=1;
                }
                LS[4].str=Integer.toString(r);
                LS[5].str=Integer.toString(s);
                repaint();
            }
            while ((BasicMath.gcd(p,q)!=1)||(q%2==0)) {                
                if (BasicMath.gcd(p,q)!=1) {
                    int g=BasicMath.gcd(p,q);                
                    p=p/g;
                    q=q/g;
               }
                if (q%2==0) {
                    q+=1;
                }
                LS[0].str=Integer.toString(p);
                LS[1].str=Integer.toString(q);
                repaint();
            }
            if (a==0) {
                a=1;
                LS[2].str=Integer.toString(a);
                repaint();
            }
            if (b<a) {
                b=a;
                LS[3].str=Integer.toString(b);
                repaint();
            }            
            
            StringWordOrganizer SO=new StringWordOrganizer();
            
            NearbySaddle ac=null;
            
            if (LS[15].str.compareTo("acute")==0) {
                ac=new Acute454590(r,s);
            } else {
                ac=new Obtuse454590(r,s);
            }
            //System.out.println(ac.saddle[0]);
            //System.out.println(ac.saddle[1]);
                        
            for (int i=a; i<=b; i++) {
                SO.add(AutGp.slope(p,q, i).buildWord(ac));
            }
            M.mcbSend(new BasicSearchResults(SO.toArray(), new Complex(0.5,0.5)));
        }
    }
    
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void keyPressed(java.awt.event.KeyEvent keyEvent) {
    }
    
    public void keyReleased(java.awt.event.KeyEvent keyEvent) {
    }
    
    public void keyTyped(KeyEvent e) {
        /* if (e.getKeyChar()==KeyEvent.VK_TAB) {
            if (selected!=-1) {
                int temp=selected;
                deselect();
                selected=(temp+2)%6;
            } else {
                selected=0;
            }
            eq[selected].setColors(Color.black, Color.yellow);
            repaint();
            return;
        } */
        if (e.getKeyChar()==KeyEvent.VK_ENTER) {
            if (selected!=-1) {
                selected=-1;
                repaint();
            }
            return;
        }
        if (selected!=-1) {
            int x=Integer.parseInt(LS[selected].str);
            int temp;
            temp=TextProcess.NonnegativeInteger(x,e);
            if (temp>=1000000)
                temp= 999999;
            if (x==temp)
                return;
            LS[selected].str=Integer.toString(temp);
            repaint();
            return;
        }
    }
    
    public void focusGained(java.awt.event.FocusEvent focusEvent) {
    }
    
    public void focusLost(java.awt.event.FocusEvent focusEvent) {
        if (selected!=-1) {
            selected=-1;
            repaint();
            return;
        }
    }
    
}
