package Current.popups.Polynomial;
import Current.*;
import Current.basic.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.math.*;


public class FunctionAnalysis {
    BigInteger[][] G=new BigInteger[4][2000];
    BigInteger[][] A=new BigInteger[0][0];
    int x_coeff,y_coeff,mod,target,symm,width,height;
    int offsetX,offsetY;
    int rangeX;
    int rangeY;

    public FunctionAnalysis(int[][] g,int[] choice) {

	Integer g00=new Integer(g[0][0]);
	G[0][0]=new BigInteger(g00.toString());

	offsetX=10000;
	offsetY=10000;
	rangeX=-10000;
	rangeY=-10000;

	if(choice[0]<2) {
	  for(int i=1;i<=g[0][0];++i) {
	    Integer a3=new Integer(g[3][i]);
	    Integer a2=new Integer(g[2][i]);
	    Integer a1=new Integer(g[1][i]);
	    if(offsetX>g[1][i]) offsetX=g[1][i];
	    if(offsetY>g[2][i]) offsetY=g[2][i];
	    if(rangeX<g[1][i]) rangeX=g[1][i];
	    if(rangeY<g[2][i]) rangeY=g[2][i];
	    G[3][i]=new BigInteger(a3.toString());
	    G[2][i]=new BigInteger(a2.toString());
	    G[1][i]=new BigInteger(a1.toString());
	  }
	}

	if(choice[0]==2) {
          for(int i=1;i<=g[0][0];++i) {
            Integer a3=new Integer(g[2][i]);
	    Integer a2=new Integer(g[1][i]);
	    Integer a1=new Integer(g[0][i]);
            if(offsetX>g[0][i]) offsetX=g[0][i];
	    if(offsetY>g[1][i]) offsetY=g[1][i];
            if(rangeX<g[0][i]) rangeX=g[0][i];
	    if(rangeY<g[1][i]) rangeY=g[1][i];
	    G[3][i]=new BigInteger(a3.toString());
	    G[2][i]=new BigInteger(a2.toString());
	    G[1][i]=new BigInteger(a1.toString());
	  }
	}

	rangeX=rangeX-offsetX;
	rangeY=rangeY-offsetY;
	if(rangeX<0) {offsetX=0;rangeX=0;}
	if(rangeY<0) {offsetY=0;rangeY=0;}

	diff(choice[1],choice[2]);
	x_coeff=choice[3];
	y_coeff=choice[4];
	mod=choice[5];
	target=choice[6];
	width=choice[8]-200;
	height=choice[9]-200;
	setValues();
	symm=0;
	if(choice[7]==1) symm=1+(choice[1]+choice[2])%2;


    }

    /**This routine takes an integer and draws it inside a square*/

    public void specialRender(int v,BigInteger q,float x,float y,float k,Graphics2D g) {

	int go=0;
	if(q.compareTo(BigInteger.ZERO)!=0) go=1;


	//background square
	GeneralPath X=new GeneralPath();
	X.moveTo(x,y);
	X.lineTo(x,y+k);
	X.lineTo(x+k,y+k);
	X.lineTo(x+k,y);
	X.closePath();
	if((go==0)&&(v==0))    g.setColor(new Color(60,0,0));
	if((go==0)&&(v==1))    g.setColor(new Color(0,0,60));
	if((go==1)&&(v==0))    g.setColor(new Color(200,0,0));
	if((go==1)&&(v==1))    g.setColor(new Color(50,120,255));
	g.fill(X);

	BigInteger qq=q.abs();
	String SQ=qq.toString();
	int size=SQ.length();



	//determine the layout for the number
	float ystart,xstart,xspace,yspace;
	int fontsize,skip;

	fontsize=(int)(k);
	    ystart=(float)(y+.8*k);
	    xstart=(float)(x+.2*k);
	    xspace=(float)(k);
	    yspace=(float)(k);
	    skip=2;

	    if(size>=2) {
		fontsize=(int)(.8*k);
	        ystart=(float)(y+.8*k);
	        xstart=(float)(x+.1*k);
	        xspace=(float)(.4*k);
	        yspace=(float)(.6*k);
	        skip=2;
	    }

	    if(size>=3) {
		fontsize=(int)(.6*k);
	        ystart=(float)(y+.42*k);
	        xstart=(float)(x+.1*k);
	        xspace=(float)(.4*k);
	        yspace=(float)(.5*k);
	        skip=2;
	    }

	    if(size>=5) {
		fontsize=(int)(.5*k);
	        ystart=(float)(y+.42*k);
	        xstart=(float)(x+.1*k);
	        xspace=(float)(.3*k);
	        yspace=(float)(.47*k);
	        skip=3;
	    }

	    if(size>=7) {
		fontsize=(int)(.4*k);
	        ystart=(float)(y+.4*k);
	        xstart=(float)(x+.05*k);
	        xspace=(float)(.25*k);
	        yspace=(float)(.4*k);
	        skip=4;
	    }

	    if(size>=9) {
		fontsize=(int)(.28*k);
	        ystart=(float)(y+.22*k);
	        xstart=(float)(x+.1*k);
	        xspace=(float)(.2*k);
	        yspace=(float)(.23*k);
	        skip=5;
	    }


	    //draw the number

	   Font font= new Font("Monospaced",Font.PLAIN,fontsize);
           g.setFont(font);
	   Color Col=Color.white;
	   if(q.compareTo(BigInteger.ZERO)==-1) Col=Color.black;

	   float xx=x;
	   float yy=ystart;
	   g.setColor(Col);
	   for(int i=0;i<size;++i) {
	   if(q.compareTo(BigInteger.ZERO)!=0)	    g.drawString(SQ.substring(i,i+1),xx,yy);
	      xx=xx+xspace;
	      if((i+1)%skip==0) {xx=x;yy=yy+yspace;}
	   }
    }







    /**taking derivatives*/

    public void diffX() {
	for(int i=1;i<=G[0][0].intValue();++i) {
	    G[3][i]=G[3][i].multiply(G[1][i]);
	} 
    }

    public void diffY() {
	for(int i=1;i<=G[0][0].intValue();++i) {
	    G[3][i]=G[3][i].multiply(G[2][i]);
	}
    }

    public void diff(int a,int b) {
	for(int i=0;i<a;++i) diffX();
	for(int j=0;j<b;++j) diffY();
    }




    public void setValues() {
	A=new BigInteger[rangeX+1][rangeY+1];
        for(int i=0;i<=rangeX;++i) {
	   for(int j=0;j<=rangeY;++j) {
	      A[i][j]=BigInteger.ZERO;
	   }
	}


        for(int i=1;i<=G[0][0].intValue();++i) {
	    int a=G[1][i].intValue();
	    int b=G[2][i].intValue();
	    A[a-offsetX][b-offsetY]=A[a-offsetX][b-offsetY].add(G[3][i]);
	}
    }



    public int getCongruence(int i,int j) {
	int m1=(x_coeff*i+y_coeff*j+100000*mod)%mod;
	int m2=(target+100000*mod)%mod;
	if(m1==m2) return(1);
	return(0);
    }


    /** this routine produces a symmetrized version of
        the modular transform.  

        mode=1  corresponds to sine symmetries
        mode=2  corresponds to cosine symmetries
        mode=3  corresponds to exp symmetries
    **/


    public int getCongruence(int i,int j,int mode) {

	int m1=(x_coeff*i+y_coeff*j+100000*mod)%mod;
	int m2=(target+100000*mod)%mod;

	if(mode==0) {
	    if(m1==m2) return(1);
	    return(0);
	}

	if(mode==1) {
	    if(m2>=mod/2) return(0);
	    if(m2==0) return(0);
	    if(m1==m2) return(1);
	    if(m1+m2==mod) return(-1);
	    return(0);
	}

	if(mode==2) {
	    if((m2>=mod/4)&&(m2<=3*mod/4)) return(0);
	    if(m1==m2) return(1);
	    if(m1+m2==mod/2) return(-1);
	    if(m1+m2==3*mod/2) return(-1);
	}

	return(0);

    }





    public void render(int opt,int x,int y,Graphics2D g) {
	float cc=(float)(Math.min(1.0*width/(rangeX+1),1.0*height/(rangeY+1)));
	for(int i=0;i<=rangeX;++i) {
	    for(int j=0;j<=rangeY;++j) {
		float xx=x+cc*i+20;
		float yy=y+cc*j+20;
		int v=getCongruence(i+offsetX,j+offsetY,symm);
		v=Math.abs(v);
		v=v*opt;
		try{specialRender(v,A[i][j],xx,yy,(float)(cc-3),g);}
		catch(Exception e){}
		g.setColor(new Color(150,150,150));
		Integer x1=new Integer(i+offsetX);
		Integer x2=new Integer(j+offsetY);
	        Font font= new Font("Helvetica",Font.PLAIN,10);
		g.setFont(font);
		if((i+offsetX)%5==0) g.drawString(x1.toString(),xx+cc/2-5,y+8);
		if((j+offsetY)%5==0) g.drawString(x2.toString(),x-1,yy+cc/2);
	    }
	}
    }






    public BigComplex evaluate() {
	BigInteger total=new BigInteger("0");
	for(int i=0;i<=rangeX;++i) {
	      for(int j=0;j<=rangeY;++j) {
		  int v=getCongruence(i+offsetX,j+offsetY,symm);
	      if(v==1) total=total.add(A[i][j]);  
              if(v==-1) total=total.subtract(A[i][j]);
	    }
	}
	BigDecimal X=new BigDecimal(total);
	BigComplex Z=new BigComplex();
	Z.x=X;
	return(Z);
    }


    
}



