package Current.popups.Polynomial;

import Current.*;
import Current.basic.*;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;
import java.math.*;




public class PolynomialDisplay {
    int TERMS,WIDTH;
    int x,y;
    ListenSquare[] L=new ListenSquare[30];
    Polynomial P;
    BigPolynomial BP;
    int mode;

    public PolynomialDisplay() {
	mode=0;
    }

    public PolynomialDisplay(Polynomial Q) {
	this.P=Q;
	mode=0;
    }

    public PolynomialDisplay(BigPolynomial BQ) {
	this.BP=BQ;
	mode=1;
    }

    public PolynomialDisplay(int x,int y,int width, int terms) {
	this.x=x;
	this.y=y;
	this.TERMS=terms;
	this.WIDTH=width;
    }


    public void render(Graphics2D g) {

	Color[] C=new Color[6];
	C[0]=new Color(200,0,0);
	C[1]=new Color(255,255,255,50);
	C[2]=new Color(50,100,255);
	C[3]=Color.white;
	C[4]=new Color(50,100,255);
	C[5]=Color.black;

	int D=P.D;
	if(mode==1) D=BP.D;

	//term slots
	for(int i=0;i<TERMS;++i) {
	    g.setColor(C[0]);
	    g.fillRect(x,y+25*i,WIDTH*6+22,25);
	    if(i%2==1) {
              g.setColor(C[1]);
	      g.fillRect(x,y+25*i,WIDTH*6+22,25);
	    }
	}

	//the polynomial terms 
        g.setFont(new Font("Monospaced",Font.PLAIN,10));

	for(int d=0;d<TERMS;++d) {
	    String XX="";
	    String YY="";

	    if(d<=D) {

		if(mode==0) {
		   double xx=P.z[D-d].x;
		   double yy=P.z[D-d].y;
		   Double X=new Double(xx);
		   Double Y=new Double(yy);
	           XX=X.toString();
	           YY=Y.toString();
		}

		if(mode==1) {
		   BigDecimal xx=BP.z[D-d].x;
		   BigDecimal yy=BP.z[D-d].y;
	           XX=xx.toString();
	           YY=yy.toString();
		   if(recognizeInteger(xx)==1) {
		       BigInteger xxx=xx.toBigInteger();
		       XX=xxx.toString();
		   }
		   if(recognizeInteger(yy)==1) {
		       BigInteger yyy=yy.toBigInteger();
		       YY=yyy.toString();
		   }
		}

	    }

	    int chopX=Math.min(WIDTH,XX.length());
	    int chopY=Math.min(WIDTH,YY.length());
            XX=XX.substring(0,chopX);
            YY=YY.substring(0,chopY);

	    g.setColor(Color.white);
	    g.drawString(XX,x+11,y+25*d+10);
	    g.drawString(YY,x+11,y+25*d+20);
	    Integer dd=new Integer(D-d);
	    g.setColor(Color.black);
	    if(YY.length()+XX.length()>1) g.drawString(dd.toString(),x+1,y+25*d+16);
	}
    }


    public int recognizeInteger(BigDecimal X) {
	int test=0;
	BigDecimal Y=X.setScale(0,BigDecimal.ROUND_FLOOR);
	if(X.compareTo(Y)==0) test=1;
	return(test);
    }


}


