package Current.popups.Polynomial;
import Current.*;
import Current.basic.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.math.*;

/**This is just a wrapper class for some precomputed
   high precision values of sine and cosine*/

public class PrecisionTrigData {
    BigDecimal[][][] A;
    int offsetX;
    int offsetY;
    int rangeX;
    int rangeY;

    public PrecisionTrigData(){}


    public PrecisionTrigData (int[][][] g,int length,int fudge,BigComplex zz) {
	offsetX=0;
	offsetY=0;
	rangeX=-1000000;
	rangeY=-1000000;

	for(int i=0;i<length;++i) {
	    for(int j=1;j<=g[i][0][0];++j) {
		int a=g[i][1-fudge][j];
	        int b=g[i][2-fudge][j];
		if(offsetX>a) offsetX=a;
		if(offsetY>b) offsetY=b;
		if(rangeX<a) rangeX=a;
		if(rangeY<b) rangeY=b;
	    }
	}
	rangeX=rangeX-offsetX;
	rangeY=rangeY-offsetY;
	A=new BigDecimal[2][rangeX+1][rangeY+1];



	for(int i=0;i<length;++i) {
	    for(int j=1;j<=g[i][0][0];++j) {
		int a=g[i][1-fudge][j];
	        int b=g[i][2-fudge][j];
		if(A[0][a-offsetX][b-offsetY]==null) {
	            BigDecimal ph1=zz.x.multiply(new BigDecimal(a));
	            BigDecimal ph2=zz.y.multiply(new BigDecimal(b));
	            BigDecimal phase=ph1.add(ph2);
	            A[0][a-offsetX][b-offsetY]=PrecisionTrig.mcbCos(phase);
	            A[1][a-offsetX][b-offsetY]=PrecisionTrig.mcbSin(phase);
		}
	    }
	}
    }

}
