/*
 * PopupManagerPopup.java
 *
 * Created on May 22, 2006, 12:28 PM
 */

package Current.popups.PopupManager;

import Current.gui.*;
import Current.manage.*;
import Current.manage.Popup.*;

import java.awt.*;
import java.awt.event.*;

import org.pat.graphics.boxed.ListenString;

/**
 *
 * @author  pat
 */
public class PopupManagerPopup extends Container {
    
    private class Title extends Canvas {
        ListenString title;
        
        public Title() {
            setBackground(new Color(0,0,100));
            setFont(new Font("sanserif", Font.PLAIN, 12));
            
            title=new ListenString("More Popups",this);
            title.setColors(Color.white, getBackground());
            title.showBorder=false;
            setSize((int)(2*padding+title.getWidth()), (int)(2*padding+title.getHeight()));
        }
        
        public void paint(Graphics gfx) {
            Graphics2D g=(Graphics2D) gfx;
            
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            title.setHorizontalCenter(getWidth()/2.0);
            title.setVerticalCenter(getHeight()/2.0);
            title.render(g);
        }
    }
    
    private class List extends DBCanvas implements MouseListener, MouseMotionListener  {
        ListenString ls[];
        
        // translation to scroll by
        int ty=0, pressed_y=0;
        
        public List() {
            setBackground(new Color(0,100,0));
            setFont(new Font("sanserif", Font.PLAIN, 12));
            
            updateData();
            setSize();
            
            this.addMouseListener(this);
            this.addMouseMotionListener(this);
        }
        
        public void setSize(){
            int x=0,y=0,temp=0;
            for (int i=0; i<ls.length; i++){
                temp=(int)(ls[i].getRight());
                if (temp>x)
                    x=temp;
                temp=(int)(ls[i].getBottom());
                if (temp>y)
                    y=temp;
            }
            setSize(x+padding,(int)(ls[ls.length-1].getBottom()+padding));
        }
        
        public void paint(Graphics gfx) {
            Graphics2D g=(Graphics2D) gfx;
            
            g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            if (ls.length>0) {
                if (((ls[ls.length-1]!=null))&&(ty<-(ls[ls.length-1].getBottom()+
                padding-getHeight())))
                    ty=-(int)(ls[ls.length-1].getBottom()+
                    padding-getHeight());
            }
            if (ty>0)
                ty=0;
            
            for (int i=0; i<ls.length; i++) {
                if (ls[i]!=null) {
                    ls[i].render(g,0,ty);
                }
            }
        }
        
        private void updateData() {
            data=M.PopupM.getData();
            ls=new ListenString[data.classes.length];
            double x=padding, y=padding;
            for (int i=0; i<data.classes.length; i++) {
                ls[i]=new ListenString(data.titles[i],this);
                if (data.up[i]) {
                    ls[i].setColors(selectedFg, selectedBg);
                } else {
                    ls[i].setColors(buttonFg, buttonBg);
                }
                ls[i].setLeft(x);
                ls[i].setTop(y);
                y=ls[i].getBottom()+padding;
            }
        }
        
        public void mouseDragged(MouseEvent e) {
            if (e.getY()!=pressed_y) {
                ty=ty+e.getY()-pressed_y;
                pressed_y=e.getY();
                repaint();
            }
        }
        
        public void mouseMoved(MouseEvent e) {
        }
        
        public void mouseClicked(MouseEvent e) {
            for (int i=0; i<ls.length;i++){
                if ((ls[i]!=null)&&(ls[i].contains(e.getX(),e.getY()-ty))) {
                    if (! M.PopupM.isUp(data.classes[i])) {
                        M.PopupM.constructPopup(data.classes[i]);
                    }
                }
            }
        }
        
        public void mouseEntered(MouseEvent e) {
        }
        
        public void mouseExited(MouseEvent e) {
        }
        
        public void mousePressed(MouseEvent e) {
            pressed_y=e.getY();
        }
        
        public void mouseReleased(MouseEvent e) {
        }
    }
    
    private Manager M;
    private PopupManager.PopupDataList data;
    private static int padding=4;
    
    private Title title;
    private List list;
    
    // Colors
    Color buttonBg, buttonFg, selectedBg, selectedFg;
    
    
    /** Creates a new instance of PopupManagerPopup */
    public PopupManagerPopup(Manager M) {
        setFont(new Font("sanserif", Font.PLAIN, 12));
        setBackground(new Color(0,100,0));
        buttonFg=Color.black;
        selectedFg=Color.black;
        buttonBg=new Color(100,255,100);
        selectedBg=Color.yellow;
        
        this.M=M;
        M.addListener(this);
        
        setLayout(new BorderLayout());
        
        title=new Title();
        list=new List();
        setSize(list.getWidth(),title.getHeight()+list.getHeight());
        
        add(title,"North");
        add(list,"Center");
    }
    
    public void mcbCleanup() {
        M.remove(this);
    }
    
    public void mcbReceive(PopupManager.PopupManagerChange msg) {
        //System.out.println("Recieved a message");
        list.updateData();
        list.repaint();
    }
}
