package Current.popups.Settings;

import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.BoxLayout;

import Current.popups.Settings.Items.SettingsObject;
import Current.manage.*;


public class ItemList extends Container implements MouseMotionListener, ComponentListener {
    Container inner;

    protected static final Class[] settings_item_constructor_parameters=
    {Manager.class, SettingsObject.class, Field.class};
    
    public ItemList(Manager M, SettingsObject so) {
        inner=new Container();
        Field[] f=so.getObject().getClass().getFields();
        Class item_controller;
        Constructor constructor;
        int y=0;
        Object[] params={M, so ,null};
        Component item=null;
        
        inner.setLayout(new BoxLayout(inner, BoxLayout.Y_AXIS));
        for (int i=0; i<f.length; i++) {
            if (M.settingsManager.setting_controller.containsKey(f[i].getType())) {
                item_controller=(Class)(M.settingsManager.setting_controller.get(f[i].getType()));
                params[2]=f[i];
                try {
                    item=
                    (Canvas)(
                    item_controller.getConstructor(
                    settings_item_constructor_parameters).newInstance(params));
                } catch (Throwable T) {
                    System.out.println("Failed to construct new settings item controller "+
                    "of type "+item_controller.getName());
                    T.printStackTrace();
                    System.exit(0);
                }
                item.setLocation(0, y);
                inner.add(item);
                y+=item.getHeight();
            }
        }
        inner.setLocation(0,0);
        inner.setSize(inner.getPreferredSize());
        add(inner);
        addMouseMotionListener(this);
        addComponentListener(this);
    }
    
    private void sizeInner() {
        Dimension in=inner.getPreferredSize();
        Dimension x=this.getSize();
        if (x.width>in.width) {
            in.width=x.width;
        }
        if (x.height>in.height) {
            in.height=x.height;
        }
        inner.setSize(in);
        validate();
    }
    
    public void mouseDragged(MouseEvent e) {}
    
    public void mouseMoved(MouseEvent e) {}
    
    public void componentHidden(ComponentEvent e) {}
    
    public void componentMoved(ComponentEvent e) {}
    
    public void componentResized(ComponentEvent e) {
        sizeInner();
    }
    
    public void componentShown(ComponentEvent e) {}
    
}

