/*
 * McbSettingsSave.java
 *
 * Created on May 12, 2006, 4:46 PM
 */

package Current.popups.Settings;

import java.awt.*;
import java.awt.event.*;

import org.pat.graphics.boxed.ListenString;

import Current.manage.*;
import Current.util.TextProcess;

/**
 *
 * @author  pat
 */
public class Save extends Canvas implements MouseListener, FocusListener, KeyListener {
    
    boolean selected=false;
    ListenString[] LS=new ListenString[3];
    
    Manager M;
    
    static int padding=4;
    static Color bgColor=new Color(0,50,100);
    
    /** Creates a new instance of McbSettingsSave */
    public Save(Manager M) {
        this.M=M;
        
        setFont(new Font("sanserif", Font.PLAIN, 12));
        
        setBackground(bgColor);
        LS[0]=new ListenString("filename:", this);
        LS[0].showBorder=false;
        LS[1]=new ListenString("MMMMMMMMMMMM", this);
        LS[2]=new ListenString("save", this);
        double x=padding, y=padding;
        for (int i=0; i<LS.length; i++) {
            LS[i].setColors(Color.white,bgColor);
            LS[i].setLeft(x);
            LS[i].setTop(y);
            y=LS[i].getBottom()+padding;
            if (i==1) {
                y+=2*padding;
            }
        }
        LS[1].str="filename";
        LS[2].setColors(Color.white,Color.blue);
        addMouseListener(this);
        addFocusListener(this);
        addKeyListener(this);
    }
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
        
        for (int i=0; i<LS.length; i++) {
            LS[i].render(g);
        }
    }
    
    public void selectColors() {
        if (! selected) {
            LS[1].setColors(Color.white,bgColor);
        } else {
            LS[1].setColors(Color.black,Color.white);
        }
    }
    
    private void save() {
        M.settings.saveProperties(LS[1].str);
    }
    
    public void mouseClicked(MouseEvent e) {
        if (LS[1].contains(e.getX(), e.getY())) {
            selected=!selected;
            selectColors();
            repaint();
            return;
        }
        if (LS[2].contains(e.getX(), e.getY())) {
            save();
        }
        if (selected) {
            selected=!selected;
            selectColors();
            repaint();
            return;
        }
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void keyPressed(java.awt.event.KeyEvent keyEvent) {
    }
    
    public void keyReleased(java.awt.event.KeyEvent keyEvent) {
    }
    
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar()==KeyEvent.VK_TAB) {
            if (!selected) {
                selected=true;
                selectColors();
                repaint();
            }
            return;
        }
        if (selected) {
            String temp=TextProcess.Filename(LS[1].str, e);
            if (temp.length()>12) {
                temp=temp.substring(0,12);
            }
            if (! LS[1].str.equals(temp)) {
                LS[1].str=temp;
                repaint();
                return;
            }
        }
        
    }
    
    public void focusGained(java.awt.event.FocusEvent focusEvent) {
    }
    
    public void focusLost(java.awt.event.FocusEvent focusEvent) {
        if (selected) {
            selected=false;
            selectColors();
            repaint();
            return;
        }
    }
    
}
