package Current.popups.Settings;

import java.lang.ref.WeakReference;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;

import javax.swing.BoxLayout;

import org.pat.util.*;

import Current.manage.*;
import Current.popups.Settings.*;
import Current.popups.Settings.Items.*;
import Current.gui.*;

/**
 *
 * @author  pat
 */
public class SettingsManager {
    
        
    protected TreeMap setting_controller=new TreeMap(new ClassComparator());

    public Manager M;
    
    
    /** Creates a new instance of McbSettingsManager */
    public SettingsManager(Manager M) {
        this.M=M;
        setting_controller.put(Color.class, ColorSetting.class);
        setting_controller.put(Boolean.TYPE, BooleanSetting.class);
        setting_controller.put(StringSelector.class, StringSelectorSetting.class);
    }
    
    public void mcbCleanup() {
        M.remove(this);
    }
    
    public Canvas getList(SettingsPopup MSP) {
        return new ListCanvas(MSP);
    }
    
    public class ListCanvas extends StringListCanvas {
        SettingsPopup MSP;
        
        public ListCanvas(SettingsPopup MSP) {
            this.MSP=MSP;
            setColors(new Color(0,50,100), new Color(100,100,255), Color.yellow, Color.black);
            Object[] os=M.settings.name_map.keySet().toArray();
            String[] names=new String[os.length];
            for (int i=0; i<os.length; i++) {
                names[i]=(String)(os[i]);
            }
            setNames(names);
            M.addListener(this);
        }
        
        public void deselect() {
        }
        
        public void select(String str) {
            SettingsObject so=(SettingsObject)(M.settings.name_map.get(str));
            MSP.setCenter(new ItemList(M,so));
        }
        
        public void mcbReceive(Settings.Message m) {
            MSP.setCenter(getList(MSP));
        }
        
        public void mcbCleanup() {
            M.remove(this);
        }
    }
}
