package Current.popups.Squarepath;

import Current.gui.*;
import Current.manage.*;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.io.Serializable;

public class SquarepathCanvas extends DBCanvas implements MouseListener {
    Manager M;
    SquarepathContainer acont;
    SquarepathControlCanvas AC;
    public ColorSettings colors;
    String word;  
    GeneralPath GP,SGP,GP2,SGP2,back,Sback;
    int[] state=new int[500];
    int[][] RANGE=new int[2][2];
    int scale=1;
 
    
    public SquarepathCanvas(Manager M,SquarepathContainer acont) {
        this.M=M;
	this.acont=acont;
        M.addListener(this);
        colors=(ColorSettings)(M.settings.getDefault(ColorSettings.class));
        word=M.getWord();
        setSize(300,300);
	setBackground(Color.black);
        addMouseListener(this);
        newWordReceived();
	GP=new GeneralPath();
	SGP=new GeneralPath();
	GP2=new GeneralPath();
	SGP2=new GeneralPath();
	back=new GeneralPath();
	Sback=new GeneralPath();



    }
    
    
    public void addSquarepathControlCanvas(SquarepathControlCanvas AC){
        this.AC=AC;
    }
    
    public static class ColorSettings implements Serializable {
        
        public String getTitle() {
            return "squarepath colors";
        }
        
    }
    

    public void newWordReceived() {
	word=Squarepath.startsWith12(word);	
        state=Squarepath.wordToSquarepath(word);
        RANGE=Squarepath.range(state);	
    }
    
    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);

	doScale();
	g.setStroke(new BasicStroke((float)(1.0)));
	g.setColor(Color.blue);
	g.draw(Sback);
	g.setColor(Color.red);
	g.setStroke(new BasicStroke((float)(4.0)));
	g.draw(SGP);	
        g.setColor(Color.white);
	g.draw(SGP2);

    }
    

    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    
    public synchronized void mouseClicked(MouseEvent e) {}


    public void setDisplay() {
	for(int i=1;i<=state[0];++i) {
	    AC.IS0[i].val=state[i];
	}
    }


    public void setSquarepath() {	
        RANGE=Squarepath.range(state);
	GP.reset();
	int[] x={0,0};
	GP.moveTo(0,0);

	GP2.reset();
	for(int i=1;i<=state[0];++i) {
	    if(AC.special==i) GP2.moveTo(x[0],x[1]);
	    if(i%2==1) x[0]=x[0]+state[i];
	    if(i%2==0) x[1]=x[1]+state[i];
	    if(AC.special==i) GP2.lineTo(x[0],x[1]);
	    GP.lineTo(x[0],x[1]);
	}

	back.reset();
	float ii=(float)(0.0);
	float r1=(float)(0.0);
	float r2=(float)(0.0);
	for(int i=RANGE[0][0];i<=RANGE[0][1];++i) {
	    ii=(float)(1.0*i);
	    r1=(float)(RANGE[1][0]*1.0);
	    r2=(float)(RANGE[1][1]*1.0);
	    back.moveTo(ii,r1);
	    back.lineTo(ii,r2);
	}

	for(int i=RANGE[1][0];i<=RANGE[1][1];++i) {
            ii=(float)(1.0*i);
            r1=(float)(RANGE[0][0]*1.0);
	    r2=(float)(RANGE[0][1]*1.0);
	    back.moveTo(r1,ii);
	    back.lineTo(r2,ii);
	}
    }






    public void doScale() {
	if(scale==1) windowScale();
	if(scale==2) trueScale();
    }


    public void windowScale() {
	int width=this.getWidth()-4;
	int height=this.getHeight()-2;

	double x1= 1.0*width/(RANGE[0][1]-RANGE[0][0]);
	double y1=1.0*height/(RANGE[1][1]-RANGE[1][0]);
	double x2=2+.5*width- (RANGE[0][0]+RANGE[0][1])*0.5*x1;
	double y2=2+.5*height-(RANGE[1][0]+RANGE[1][1])*0.5*y1;

	AffineTransform AT1=AffineTransform.getScaleInstance(x1,y1);
	AffineTransform AT2=AffineTransform.getTranslateInstance(x2,y2);
	AffineTransform AT3=AffineTransform.getScaleInstance(1,-1);
	AffineTransform AT4=AffineTransform.getTranslateInstance(0,height+2);

	SGP=new GeneralPath(GP);
	SGP.transform(AT1);
	SGP.transform(AT2);
	SGP.transform(AT3);
	SGP.transform(AT4);

	SGP2=new GeneralPath(GP2);
	SGP2.transform(AT1);
	SGP2.transform(AT2);
	SGP2.transform(AT3);
	SGP2.transform(AT4);

	Sback=new GeneralPath(back);
	Sback.transform(AT1);
	Sback.transform(AT2);
	Sback.transform(AT3);
	Sback.transform(AT4);

    }




    public void trueScale() {
	int width=this.getWidth()-4;
	int height=this.getHeight()-2;
	double ax1= 1.0*width/(RANGE[0][1]-RANGE[0][0]);
	double ay1=1.0*height/(RANGE[1][1]-RANGE[1][0]);
	double x1=Math.min(ax1,ay1);
	double x2=2+.5*width- (RANGE[0][0]+RANGE[0][1])*0.5*x1;
	double y2=2+.5*height-(RANGE[1][0]+RANGE[1][1])*0.5*x1;
	AffineTransform AT1=AffineTransform.getScaleInstance(x1,x1);
	AffineTransform AT2=AffineTransform.getTranslateInstance(x2,y2);
	AffineTransform AT3=AffineTransform.getScaleInstance(1,-1);
	AffineTransform AT4=AffineTransform.getTranslateInstance(0,height+2);

	SGP=new GeneralPath(GP);
	SGP.transform(AT1);
	SGP.transform(AT2);
	SGP.transform(AT3);
	SGP.transform(AT4);

	SGP2=new GeneralPath(GP2);
	SGP2.transform(AT1);
	SGP2.transform(AT2);
	SGP2.transform(AT3);
	SGP2.transform(AT4);

	Sback=new GeneralPath(back);
	Sback.transform(AT1);
	Sback.transform(AT2);
	Sback.transform(AT3);
	Sback.transform(AT4);
    }

    
    
    /** This is called when the popup is closed */
    public void mcbCleanup() {
        M.remove(this);
    }
    
    public void mcbReceive(ColorSettings s) {
        repaint();
    }
    
    /** This will be called when a new tile is selected or a new word is selected */
    public void mcbReceive(Tile t) {
        word=t.getStringWord();
        newWordReceived();
    }    
    
    

    
}



