package Current.popups.Squarepath;

import Current.*;
import Current.gui.*;
import Current.basic.*;
import Current.manage.*;
import Current.plot.Plotters.*;
import Current.popups.ListPlotter.WordList;

import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

// added by pat
import java.util.LinkedList;
import Current.popups.Memory.TilePlotQueue;

public class SquarepathControlCanvas extends DBCanvas implements KeyListener, MouseListener {
    Manager M;
    SquarepathCanvas A;
    SquarepathContainer AContainer; 
    ListenSquare[] L=new ListenSquare[10];
    IntegerSquare[] IS0=new IntegerSquare[500];
    IntegerSquare[] IS1=new IntegerSquare[500];
    IntegerSquare LIM0,LIM1;
    int special=-1;
    IntegerSelector I;
    IntegerSelector VEC;
    ListenSquare[] V=new ListenSquare[25];
    int choice=1;
    int mode=1;
    int dimension=0;
    int[][] state=new int[20][200];
    int[][] limits=new int[30][2];
    
    // added by pat
    // this plots a list of tiles
    TilePlotQueue tpq;
    // you can see if it is plotting with tpq.running();
    // you can stop it with tpq.stop()
    
    public SquarepathControlCanvas(Manager M, SquarepathCanvas A) {
	setBackground(Color.black);
        this.M=M;
        this.A=A;
        addMouseListener(this);
	M.addListener(this);
	addKeyListener(this);
        
        // added by pat
        tpq=new TilePlotQueue(M);


	I=new IntegerSelector(17,2,35,15,300,200,1000,50);
	L[0]=new ListenSquare(102,2,15,15,Color.white);   //grab word
	L[3]=new ListenSquare(102,20,15,15,Color.white);  //send word
	L[1]=new ListenSquare(198,2,15,15,Color.white);   //window scaling
	L[2]=new ListenSquare(198,20,15,15,Color.white);  //true scaling
	L[4]=new ListenSquare(65,40,12,12,Color.white);  //display
	L[5]=new ListenSquare(65,55,12,12,Color.white);  //display&act
	L[6]=new ListenSquare(65,70,12,12,Color.white);  //compute displacement (diff)	
        L[7]=new ListenSquare(5,74,20,20,Color.white);   //compute easy basis for cube
	L[8]=new ListenSquare(155,55,20,20,Color.white); //do grand plot
	L[9]=new ListenSquare(0,0,12,12,Color.white); //documentation

	LIM0=new IntegerSquare(62,100,40,15,0);    //set cube parameter lower limit
	LIM1=new IntegerSquare(107,100,40,15,0);   //set cube parameter upper limit
	VEC=new IntegerSelector(5,40,30,13,4,1,10,1);     //select number of vectors

	L[1].on=1;   //first vector selected	
        L[4].on=1;   //window scale selected

	//current state recorder
	for(int i=1;i<=200;++i) {
	    IS0[2*i-1]=new IntegerSquare(15,140+20*i,40,15,0);
	    IS0[2*i-0]=new IntegerSquare(85,140+20*i,40,15,0);
	}

	//current displacement vector recorder
	for(int i=1;i<=200;++i) {
	    IS1[2*i-1]=new IntegerSquare(165,140+20*i,40,15,0);
	    IS1[2*i-0]=new IntegerSquare(235,140+20*i,40,15,0);
	}

	//vector index
	for(int i=1;i<=10;++i) {
	    if(i<=10) V[i]=new ListenSquare(150+12*i,98,12,12,Color.white);
	}
	V[1].on=1;

	//set all cube limits to 0
	for(int i=1;i<=20;++i) {
            limits[i][0]=0;
	    limits[i][1]=0;
	}

    }

    // set this if it is contained in an UnfoldContainer
    public void addSquarepathContainer(SquarepathContainer UContainer){
        this.AContainer=AContainer;
    }

    
    public void paint(Graphics gfx) {
        Graphics2D g=(Graphics2D) gfx;
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);
	renderWordGrabber(g);
	renderSideSelector(g);
	renderVectorSelector(g);	
        L[9].infoRender(g);
    }



    public void renderWordGrabber(Graphics g) {
	g.setColor(new Color(0,100,50));
	g.fillRect(0,0,this.getWidth()-1,38);
	g.setColor(Color.white);
	g.drawRect(0,0,this.getWidth()-1,38);
	for(int i=0;i<4; ++i)	L[i].render(g,Color.red);
	I.render(g,Color.black,Color.white,Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
	g.setColor(Color.white);
	g.drawString("window length",10,30);
	g.drawString("grab word",122,12);	
	g.drawString("send word",122,30);	
        g.drawString("window scale",218,12);
        g.drawString("true scale",218,30);
    }


    public void renderSideSelector(Graphics2D g) {
	g.setColor(new Color(0,50,255));
	g.fillRect(0,120,150,dimension*10+40);
	g.setColor(Color.white);  
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
	g.drawRect(0,120,150,dimension*10+40);
	g.drawString("current state",6,132);
	for(int i=1;i<=dimension;++i) {
            IS0[i].render(g,Color.black,Color.blue,Color.orange,Color.white);
	}
	int[] temp=copyCurrent();
	int[] x=Squarepath.stateSum(temp);
	Integer X0=new Integer(x[0]);
	Integer X1=new Integer(x[1]);
	g.setColor(Color.white);
	if(x[0]!=0) g.setColor(new Color(200,200,200));
	g.drawString(X0.toString(),20,152);
	g.setColor(Color.white);
	if(x[1]!=0) g.setColor(new Color(200,200,200));
	g.drawString(X1.toString(),90,152);
    }


    public void renderVectorSelector(Graphics2D g) {

	g.setColor(new Color(160,0,160));
	g.fillRect(0,38,60,82);
	g.setColor(Color.white);
	g.drawRect(0,38,60,82);
	g.setColor(new Color(0,120,120));
	g.fillRect(60,38,90,82);
	g.setColor(Color.white);
	g.drawRect(60,38,90,82);
	g.setColor(new Color(0,0,220));
	g.fillRect(150,90,150,30);
	g.setColor(Color.white);
	g.drawRect(150,90,150,30);
	g.setColor(new Color(0,0,220));
	g.fillRect(150,120,150,dimension*10+40);
	g.setColor(Color.white);
	g.drawRect(150,120,150,dimension*10+40);
	g.setColor(new Color(70,0,130));
	g.fillRect(150,38,150,52);
	g.setColor(Color.white);
	g.drawRect(150,38,150,52);
	
	Integer X=new Integer(choice);   
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
        g.drawString("vector "+X.toString(),156,132);
	for(int i=1;i<=dimension;++i) {
            IS1[i].render(g,Color.black,Color.blue,Color.orange,Color.white);
	}
	VEC.render(g,Color.black,Color.white,Color.white);
	for(int i=4;i<=8;++i) L[i].render(g,new Color(50,100,250));
	for(int i=1;i<=VEC.val;++i) V[i].render(g,Color.red);
	g.setColor(Color.white);  
        g.setFont(new Font("Helvetica",Font.PLAIN,10));
	g.drawString("vectors",6,63);
	g.drawString("easy basis",6,104);
	g.drawString("(up to 10)",6,116);
	g.drawString("display",82,50);
	g.drawString("display & act",82,65);
	g.drawString("grab diff",82,80);
	g.drawString("set limits",82,95);
	g.drawString("grand orbit plot",185,68);
	LIM0.render(g,Color.black,Color.blue,Color.orange,Color.white);
	LIM1.render(g,Color.black,Color.blue,Color.orange,Color.white);

	state[choice][0]=dimension;
	int[] x=Squarepath.stateSum(state[choice]);
	Integer X0=new Integer(x[0]);
	Integer X1=new Integer(x[1]);
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	if(x[0]!=0) g.setColor(new Color(200,200,200));
	g.drawString(X0.toString(),170,152);
	g.setColor(Color.white);
	if(x[1]!=0) g.setColor(new Color(200,200,200));
	g.drawString(X1.toString(),240,152);
    }


    /**makes sure both arrays have the same signs 0 means yes*/

    public int compare(int[] s1,int[] s2) {
	int fail=0;
	for(int i=1;i<=s1[0];++i) {
	    if(s1[i]==0) fail=1;
	    if(s2[i]==0) fail=1;
            if((s1[i]<0)&&(s2[i]>0)) fail=1;
	    if((s1[i]>0)&&(s2[i]<0)) fail=1;
	}
	return(fail);
    }


    public int[] add(int[] s1,int[] s2,int q) {
	int[] temp=new int[s1[0]+1];
	for(int i=1;i<=s1[0];++i) {
	    temp[i]=s1[i]+s2[i]*q;
	}
	temp[0]=s1[0];
	return(temp);
    }


    public void makeNewState(int[] temp) {
       for(int i=1;i<=dimension;++i) {
	      A.state[i]=temp[i];
	      IS0[i].val=A.state[i];
       }
       A.setSquarepath();
    }


    public void act(int q) {
	int[] temp=add(A.state,state[choice],q);
	int fail=compare(temp,A.state);
	if(fail==0) makeNewState(temp);
    }

    public int[] copyCurrent() {
	int[] temp=new int[dimension+1];
	temp[0]=dimension;
	for(int i=1;i<=temp[0];++i) {
	    temp[i]=IS0[i].val;
	}
	return(temp);
    }





   public void grabWord() {
          A.newWordReceived();
	  A.setSquarepath();
	  A.setDisplay();
	  dimension=A.state[0];
   }

    public void sendWord() {
	int[] temp=copyCurrent();
	String W=Squarepath.squarepathToWord(temp);
	W=Squarepath.toPalindrome(W);
	M.mcbSend(new SearchTile(W));
	A.RANGE=Squarepath.range(temp);
    }


    public void grabDiff() {
	String ww=M.getWord();
	ww=Squarepath.startsWith12(ww);
        int[] temp=Squarepath.wordToSquarepath(ww);
	int test=1;


	System.out.println("compete");
	for(int i=1;i<=dimension;++i) {
	    System.out.println(IS0[i].val+"    "+temp[i]);
	}

	if(dimension!=temp[0]) test=0;
	if(test==1) {
	    for(int i=1;i<=temp[0];++i) {
		if((IS0[i].val<0)&&(temp[i]>0)) test=0;
		if((IS0[i].val>0)&&(temp[i]<0)) test=0;
	    }
	}
	if(test==1) {
	  for(int i=1;i<=temp[0];++i) {
	    state[choice][i]=temp[i]-IS0[i].val;
	    IS1[i].val=      temp[i]-IS0[i].val;
	  }
	}
    }




    public void determineMode(Point X) {
	int test=-1;
	for(int i=4;i<=6;++i) {
	   if(L[i].inside(X)==1) test=i;
	}
	if(test!=-1) {
	    for(int i=4;i<=6;++i) L[i].on=0;
	    L[test].on=1;
	}
    }

    public void determineVector(Point X,int q) {
	int test=-1;
	for(int i=1;i<=VEC.val;++i) {
	if(V[i].inside(X)==1) test=i;
	}

	if(test!=-1) {
	    for(int i=1;i<=VEC.val;++i) {
		V[i].on=0;
	    }
	    V[test].on=1;
	    choice=test;
	    for(int i=1;i<=dimension;++i) {
		IS1[i].val=state[test][i];
	    }
	}

	if(test!=-1) {
	    if((q==1)&&(L[5].on==1)) act(-1);
	    if((q!=1)&&(L[5].on==1)) act(1);
	   if(L[6].on==1) grabDiff();
	   LIM0.val=limits[test][0];
	   LIM1.val=limits[test][1];
	}
    }



    public void determineScale(Point X) {
              int test=-1;
	      for(int i=1;i<=2;++i) {
		  if(L[i].inside(X)==1) test=i;
	      }
	      if(test!=-1) {
		  L[1].on=0;
		  L[2].on=0;
		  L[test].on=1;
		  A.scale=test;
		  A.doScale();
	      }
    }



   
    public void determineIntegerEntry(Point X) {
	int test=-1;
	for(int i=1;i<=dimension;++i) {
	    IS0[i].on=0;
	    if(IS0[i].inside(X)==1)  test=i;
	}
        if(test!=-1) IS0[test].on=1;
        if(test!=-1) special=test;
    }

   
    public void determineVectorEntry(Point X) {
	int test=-1;
	for(int i=1;i<=dimension;++i) {
	    IS1[i].on=0;
	    if(IS1[i].inside(X)==1)  test=i;
	}
        if(test!=-1) IS1[test].on=1;
        if(test!=-1) special=test;
    }

    public void determineLimitEntry(Point X) {
	int test=-1;
	if(LIM0.inside(X)==1) test=0;
	if(LIM1.inside(X)==1) test=1;
	LIM0.on=0;
	LIM1.on=0;
	if(test==0) LIM0.on=1;
	if(test==1) LIM1.on=1;
    }


//right now the basis is cut short if it exceeds 10 vectors

    public void easyBasis() {
	int n=dimension-2;
	if(n>10) n=10;

	for(int i=1;i<=n/2;++i) {
	    state[i][0]=dimension;
	    state[i][1]=1;
	    state[i][2*i+1]=-1;
	}

	for(int i=n/2+1;i<=n;++i) {
	    state[i][0]=dimension;
	    state[i][2]=1;
	    state[i][2*i+2-n]=-1;
	}

	VEC.val=n;
    }



    public void debugPath(int[] temp) {
	System.out.print("debug path: ");
	for(int i=1;i<=temp[0];++i) {
	    System.out.print(temp[i]+" ");
	}
    System.out.println("");
    }






    public void windowResize(Point X) {
	I.modify(X);
	if(I.isModified(X)==1) this.setSize(this.getWidth(),I.val);
    }

   

    public void mouseEntered(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {
	MouseData J=MouseData.process(M,e);
	if(L[0].inside(J.X)==1) grabWord();
	if(L[3].inside(J.X)==1) sendWord();
	if(L[7].inside(J.X)==1) easyBasis();
	if(L[8].inside(J.X)==1) grandOrbitPlot();
	if(L[9].inside(J.X)==1) document();

	determineScale(J.X);
	determineIntegerEntry(J.X);	
        determineVectorEntry(J.X);
	determineLimitEntry(J.X);
	determineMode(J.X);
	determineVector(J.X,J.mode);
	VEC.modify(J.X);
	windowResize(J.X);
	A.repaint();
	repaint();
    }


     public void keyTyped(KeyEvent e) {

       for(int i=1;i<=dimension;++i)  {
	   if(IS0[i].on==1) {
                IS0[i].modifySign(e);
		A.state[i]=IS0[i].val;
                A.setSquarepath();
	   }
       }

       for(int i=1;i<=dimension;++i)  {
	   if(IS1[i].on==1) {
                IS1[i].modifySign(e);
		state[choice][i]=IS1[i].val;
	   }
       }

       if(LIM0.on==1) {
              LIM0.modifySign(e);
	      if(LIM0.val<=LIM1.val) {
		  limits[choice][0]=LIM0.val;
                  limits[choice][1]=LIM1.val;
	      }
       }

       if(LIM1.on==1) {
              LIM1.modifySign(e);
	      if(LIM0.val<=LIM1.val) {
		  limits[choice][0]=LIM0.val;
                  limits[choice][1]=LIM1.val;
	      }
       }




       A.repaint();
       repaint();

     }
     public void keyPressed(KeyEvent e) {}
     public void keyReleased(KeyEvent e) {}



    public void document() {
        M.mcbSend(new HelpDocument("SquarepathCanvas.html"));
    }    


    public void grandOrbitPlot() {
        //added by pat
        //tpq=new TilePlotQueue(M);
        WordList wl=new WordList();
        
	int total=1;
	int nontrivial=0;
	int width=0;
	for(int i=1;i<=VEC.val;++i) {
	    width=limits[i][1]-limits[i][0];
	    if(width>0) {
		nontrivial=1;
		total=total*width;
	    }
	}
        
        /** begin added by pat */
        Interrupter I=new Interrupter();
        LinkedList words=new LinkedList();
        /** end added by pat */

	int[] temp0=copyCurrent();
	int[] temp1=copyCurrent();

	for(int i1=limits[1][0];i1<=limits[1][1];++i1) {
	for(int i2=limits[2][0];i2<=limits[2][1];++i2) {
	for(int i3=limits[3][0];i3<=limits[3][1];++i3) {
	for(int i4=limits[4][0];i4<=limits[4][1];++i4) {
	for(int i5=limits[5][0];i5<=limits[5][1];++i5) {
	for(int i6=limits[6][0];i6<=limits[6][1];++i6) {
	for(int i7=limits[7][0];i7<=limits[7][1];++i7) {
	for(int i8=limits[8][0];i8<=limits[8][1];++i8) {
	for(int i9=limits[9][0];i9<=limits[9][1];++i9) {
	for(int i10=limits[10][0];i10<=limits[10][1];++i10) {
	    temp1=copyCurrent();
	    temp1=add(temp1,state[1],i1);
	    temp1=add(temp1,state[2],i2);
	    temp1=add(temp1,state[3],i3);
	    temp1=add(temp1,state[4],i4);
	    temp1=add(temp1,state[5],i5);
	    temp1=add(temp1,state[6],i6);
	    temp1=add(temp1,state[7],i7);
	    temp1=add(temp1,state[8],i8);
	    temp1=add(temp1,state[9],i9);
	    temp1=add(temp1,state[10],i10);
	    if(compare(temp0,temp1)==0) {
	      String ww=Squarepath.squarepathToWord(temp1);
	      ww=Squarepath.toPalindrome(ww);
              wl.add(ww);
	    }
        }}}}}}}}}}
               
        M.mcbSend(wl);
    }



}
