

/*
 * UnfoldingData.java
 *
 * Created on May 24, 2006, 2:01 PM
 */

/**
 *
 * @author  pat
 */

package Current.popups.Unfold;

import Current.*;
import Current.basic.*;
import Current.manage.*;

public class UnfoldingData  {
    public interface UnfoldingDataWatcher {
        public void updatedUnfoldingData();
    }
    
    private Manager M;
    
    public String word;
    public ListenTriangle[] T;
    public int[] Top,Bot; //vertex labels to the left and right of an edge
    public double top,bot; // y corrdinates of end points of strips
    public boolean good=false;
    
    public Complex Z;
    private UnfoldingDataWatcher watcher;
    
    
    public UnfoldingData(Manager M) {
        this.M=M;
        word=M.getWord();
        Z=M.getZ();
        update();
        M.addListener(this);
        M.addListener(this);
    }
    
    public void setWatcher(UnfoldingDataWatcher w) {
        watcher=w;
    }
    
    public void update() {
        
        //// UNFOLDING
        T=new ListenTriangle[word.length()];
        T[0]=ListenTriangle.init(Z);
        T[0].reflectMe(word.charAt(0)-'1');
        for (int i=1;i<T.length; i++) {
            T[i]=T[i-1].reflect(word.charAt(i)-'1');
        }
        Complex w =T[0].z[(((int)(word.charAt(0)-'1'))+1)%3].
        minus(T[word.length()-1].z[(((int)(word.charAt(0)-'1'))+1)%3]);
        w=w.conjugate();
        for (int i=0;i<T.length; i++) {
            T[i]=T[i].rotate(w);
        }
        // now the unfolding is horizontal.
        
        ///// VERTEX LABELS
        Top=new int[word.length()];
        Bot=new int[word.length()];
        for (int i=0;i<word.length();i++) {
            switch (i%2) {
                case 1:
                    Top[i]=(((int)(word.charAt(i)-'1'))+1)%3;
                    Bot[i]=(((int)(word.charAt(i)-'1'))+2)%3;
                    break;
                case 0:
                    Top[i]=(((int)(word.charAt(i)-'1'))+2)%3;
                    Bot[i]=(((int)(word.charAt(i)-'1'))+1)%3;
                    break;
            }
        }
        
        top=T[0].z[Top[0]].y;
        bot=T[0].z[Bot[0]].y;
        for (int i=1; i<word.length();i++) {
            if (T[i].z[Top[i]].y<top)
                top=T[i].z[Top[i]].y;
            if (T[i].z[Bot[i]].y>bot)
                bot=T[i].z[Bot[i]].y;
        }
        good=(top>bot);
        
        if (watcher!=null) {
            watcher.updatedUnfoldingData();
        }
        
        // Debugging
        //        System.out.println("Top is: "+top);
        //        System.out.println("Bot is: "+bot);
        //        if (top>bot) {
        //            System.out.println("Good");
        //        } else {
        //            System.out.println("Bad");
        //        }
    }
    
    
    public void mcbReceive(Parameter p) {
        Z=p.getZ();
        update();
    }
    
    
    public String getTitle() {
        return "UnfoldingData";
    }
    
    public void readSettings() {
    }
    
    public void mcbReceive(Tile t) {
        word=t.getStringWord();
        update();
    }

    public void mcbCleanup() {
        M.remove(this);
    }
    
}
