/*
 * PatList.java
 *
 * Created on October 19, 2005, 11:00 PM
 */

package Current.search.basic;

import java.util.*;

import Current.basic.*;

/**
 * This is a replacement for java.util.LinkedList as needed by the Slalom Search.
 * I hope it will run faster.
 * @author  pat
 */
public class ComplexList {
    public LinkedList lst; // we think of this as ordered data
    
    public ComplexList() {
        lst=new LinkedList();
    }
        
    public final Complex[] extractData(){
//        Complex[] ret=new Complex[lst.size()];
//        int i=0;
//        for (ListIterator it=lst.listIterator(); it.hasNext(); ) {
//            ret[i++]=(Complex)(it.next());
//        }
//        return ret;
        return (Complex[])(lst.toArray(new Complex[lst.size()]));
    }
    
    /** replaces the data stored in this PatList with the data in
     * this array */
    public final void replaceData(Complex data[]){
        lst=new LinkedList();
        for (int i=0; i<data.length; i++) {
            lst.addLast(data[i]);
        }
    }
    
    /** add a copy of z */
    public final void addLast(Complex z) {
        lst.addLast(new Complex(z));
    }
    
    /** add a copy of z */
    public final void addFirst(Complex z) {
        lst.addFirst(new Complex(z));
    }
    
    
    public final int size() {
        return lst.size();
    }
    
    //    public Complex get(int i) {
    //        return lst[(first+i)%lst.length];
    //    }
    
    public final Complex getFirst(){
        return (Complex)(lst.getFirst());
    }
    
    public final Complex getSecond(){
        ListIterator it=lst.listIterator(1);        
        return (Complex)(it.next());
        
        //        Complex
        //        first=((Complex)(lst.removeFirst())),
        //        second=((Complex)(lst.getFirst()));
        //        lst.addFirst(first);
        //        return second;
    }
    
    public final Complex getLast(){
        return (Complex)(lst.getLast());
    }
    
    public final Complex getSecondToLast(){
        ListIterator it=lst.listIterator(lst.size()-1);
        return (Complex)(it.previous());
        
        //        Complex
        //        first=((Complex)(lst.removeLast())),
        //        second=((Complex)(lst.getLast()));
        //        lst.addLast(first);
        //        return second;
    }
    
    
    public final void removeFirst(){
        lst.removeFirst();
    }
    
    public final void removeLast(){
        lst.removeLast();
    }
    
    
    
}
