// This code impliments the Slalom Search algorithm 
// See the McBilliards documentation for more information 
// on this search algorithm

// There are currently very few comments in the code, and so it is difficult 
// to understand but me. Perhaps I will fix this eventually.
// -Pat Hooper pat@math.sunysb.edu

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#define Pi 3.141592653589
#include "plist.c"


void slalom(file1, file2)
  FILE *file1, *file2;
{
  pcomplex z;
  ptriangle T;
  word_link wl=NULL;
  int s;

  fscanf(file1,"%lf",&z.x); // the first angle of our triangle
  fscanf(file1,"%lf",&z.y); // the second angle of our triangle
  fscanf(file1,"%d",&s);    // the depth to search to

  T=ptriangle_make2(z);      // create one of my triangles

  wl=psearch(T,s);         // search for some words

  word_link_print_file(file2,wl); // print the list to the output file

  fclose(file1);
  fclose(file2);

  word_link_destroy(wl);
}

void rational_slalom(file1, file2)
  FILE *file1, *file2;
{
  pcomplex z;
  ptriangle T;
  word_link wl=NULL;
  int s, rel[3];

  fscanf(file1,"%lf",&z.x); // the first angle of our triangle
  fscanf(file1,"%lf",&z.y); // the second angle of our triangle
  fscanf(file1,"%d",&s);    // the depth to search to
  fscanf(file1,"%d",&rel[1]);    // the depth to search to
  fscanf(file1,"%d",&rel[2]);    // the depth to search to
  rel[0]=-rel[2];
  rel[2]-=rel[1];

  T=ptriangle_make2(z);      // create one of my triangles

  wl=psearchwRel(T,s,rel);         // search for some words

  word_link_print_file(file2,wl); // print the list to the output file

  fclose(file1);
  fclose(file2);

  word_link_destroy(wl);
}

void multi_slalom(file1, file2)
     FILE *file1, *file2;
{
  pcomplex *z;
  ptriangle *T;
  //pword_list wl; //old version
  word_link wl;
  int i,num;

  fscanf(file1,"%d",&num); // Read the number of points from the file

  z=(pcomplex *) malloc(num*sizeof(pcomplex));
  T=(ptriangle *) malloc(num*sizeof(ptriangle));
  
  for (i=0; i<num; i++){
    fscanf(file1,"%lf",&(z[i].x)); // the first angle of our triangle
    fscanf(file1,"%lf",&(z[i].y)); // the second angle of our triangle
    T[i]=ptriangle_make2(z[i]);      // create one of my triangles
  }

  fscanf(file1,"%d",&i);    // the depth to search to

  free(z); // once we have the triangle we no longer need z

  wl=multi_psearch(T,num,i);         // search for some words

  word_link_print_file(file2,wl); // print the list to the output file

  fclose(file1);
  fclose(file2);

  word_link_destroy(wl);

  free(T);
}

/* int main(){ */
/*   int s; */

/*   fscanf(stdin,"%d",&s); // Read the option value from the file */

/*   if (s==999){ */
/*     slalom(stdin,stdout); */
/*     }  */

/*   if (s==998){ */
/*     multi_slalom(stdin,stdout); */
/*   }  */

/*   if (s==997){ */
/*     rational_slalom(stdin,stdout); */
/*   }  */


/*   return 0; */
/* } */

int main(){
  slalom(stdin,stdout);
  return 0;
}
